#include <stdio.h>
#include "COVFile.h"

COVFile::COVFile(const char* cov_filename)
{
	readsuccess=true;
	// open file
	filename = cov_filename;
	FILE *covf = fopen(filename,"r");
	if (covf!=NULL){
		// read file
		ReadCOVFile(covf);
	}else{
		readsuccess=false;
	}
	// close file
	fclose(covf);
}

// Read OKC file
void COVFile::ReadCOVFile(FILE* covfile)
{
	int i,j,temp;
	
	//read header
	fscanf(covfile, "%d%d\n", &ndata, &temp);
	if (ndata==0)
		readsuccess = false;

	//initialize data
	dataset = new double*[ndata];
	for (i=0;i<ndata;i++){
		dataset[i] = new double[ndata];
		for (j=i;j<ndata;j++){
			dataset[i][j] = 0;
		}
	}

	//read data
	for (i=0;i<ndata;i++){
		for (j=i;j<ndata;j++){
			fscanf(covfile, "%lf", &value);
			dataset[i][j] = value ;
			dataset[j][i] = value ;
		}
	}	

}

// print dataset (for testing purposes only)
void COVFile::Print()
{
	// print data
	for (int i=0;i<ndata;i++){
		for (int j=0;j<ndata;j++)
			cout << dataset[i][j] ;
		cout << endl;
	}
}







