#include "HCurve.h"
// Adapted from http://www-fs.informatik.uni-tuebingen.de/~reinhard/hcurve.html


	bool HCurve::iseven(int i){
		if ((i%2)==0)
			return true;
		else
			return false;
	}


	//-- Constuctor ------------------------------------------------
	HCurve::HCurve(int n,int m){
	
		width = n;
		height = m;
		if ((width==height) && iseven(width) && iseven(height)){
			// square grid method will be used
			squaregrid=true;	
		}else{
			// Initialise Rectangle Grid
			squaregrid=false;
			for (int i=0;i<257;i++){
				bfel[i]=0;				
				for (int j=0;j<257;j++)
					bfeld[i][j]=0;
			}
			Rect* r = felds(width,height);
		}
	}

	int HCurve::xco(int i){		
		if (squaregrid)
			return xco_sqr(i,width);
		else
			return xco_rect(i);
	}

	int HCurve::yco(int i){ 
		if (squaregrid)
			return yco_sqr(i,width);
		else
			return yco_rect(i);
	}

	//--- X-Coordinate (rectangular grid)---------------------------
	int HCurve::xco_rect(int i){
		return feld[width][height]->xcor(i); 
	}

	//--- Y-Coordinate (rectangular grid)---------------------------
	int HCurve::yco_rect(int i){
		return feld[width][height]->ycor(i); 
	}

	//--- X-Coordinate (square grid)--------------------------------
	int HCurve::xco_sqr(int i, int n){
		int acht = 2*(n/4)*(n/4);
		int halb = 2*(n/4);
		if (i < 2) {return 0;} else {
			if (i >= n*n/2) {return (n - xco_sqr((i-n*n/2),n) - 1);} else{
				if (i < acht) {return xco_sqr(i, halb);} else{
					if (i >= n*n/2 - acht) {
						return n-halb+xco_sqr(i-n*n/2+acht, halb);} else{
          if (2*halb == n){
             return halb-xco_sqr(n*n/2-acht-1-i, halb)-1;} else{
             return n-halb-xcod(n*n/2-acht-1-i, n-halb)-1;
      }}}}}
    }
	int HCurve::xcod(int i,int n)
    {
		int acht = 2*(n/4)*(n/4);
		int halb = 2*(n/4);
		  if (n <= 4) {
		   if (i==0) {return 0;} else {
			if (i<1+n) {return i-1;} else {
			 if (i<2*n) {return 2*n-i;} else {
			  return (i+6-3*n)/2;
		   }}}
		  } else {
		   if (n == 6) {
			if (i<4) {return 0;} else {
			 if (i<7) {return 1;} else {
			  if (i<10) {return 2;} else {
			   if (i<16) {return (i-4)/2;} else {
				if (i<23) {return (27-i)/2;} else {
				 if (i<26) {return 1;} else {
				  if (i<28) {return 2;} else {
				   if (i<31) {return i-25;} else {
						return 36-i;
			}}}}}}}}
		   } else {
			if (i < acht-4) {return xcod(i, halb);} else{
			 if (i >= n*n - acht -4) {return xcod(i + 2*acht -n*n, halb);} else{
			  if ((i >= n*n/2 - acht -4) && (i < n*n/2 + acht -4))
				 {return (n - halb + xco_sqr((i-n*n/2+acht+4),halb));} else{
			   if (i >= n*n/2 - 4) {
				  return n-xco_sqr(i-n*n/2+4, n)-1;} else{
				if (2*halb == n){
				   return halb-xco_sqr(n*n/2-acht-5-i, halb)-1;} else{
				   return n-halb-xcod(n*n/2-acht-5-i, n-halb)-1;
		  }}}}}}}
    }
    
	//--- X-Coordinate (square grid)--------------------------------
	int HCurve::yco_sqr(int i, int n)
    {
		int acht = 2*(n/4)*(n/4);
		int halb = 2*(n/4);
		  if (i < 2) {return i;} else {
		   if (i >= n*n/2) {return (n - yco_sqr((i-n*n/2),n) - 1);} else{
			if (i < acht) {return yco_sqr(i, halb);} else{
			 if (i >= n*n/2 - acht) {
				return n-halb+yco_sqr(i-n*n/2+acht, halb);} else{
			  if (2*halb == n){
				 return halb+yco_sqr(n*n/2-acht-1-i, halb);} else{
				 return halb+ycod(n*n/2-acht-1-i, n-halb);
		  }}}}}
    }
	int HCurve::ycod(int i, int n)
    {
		int acht = 2*(n/4)*(n/4);
		int halb = 2*(n/4);
		  if (n <= 4) {
		   if (i==0) {return n-2;} else {
			if (i<1+n) {return n-1;} else {
			 if (i<2*n) {return n-2;} else {
			  if (i<10) {return (9-i)*(n-3);} else {
			   if (i<12) {return i-10;} else {
				return 13-i;
		   }}}}}
		  } else {
		   if (n == 6) {
			if (i<4) {return i+2;} else {
			 if (i<7) {return 9-i;} else {
			  if (i<10) {return i-4;} else {
			   if (i<12) {return 15-i;} else {
				if (i<14) {return i-8;} else {
				 if (i<18) {return 19-i;} else {
				  if (i<20) {return i-16;} else {
				   if (i<22) {return 23-i;} else {
					if (i<24) {return 2;} else {
					 if (i<25) {return 1;} else {
					  if (i<27) {return 0;} else {
					   if (i<31) {return 1;} else {
						return 0;
			}}}}}}}}}}}}
		   } else {
			if (i < acht-4) {return ycod(i, halb);} else{
			 if (i >= n*n - acht -4) {return ycod(i + 2*acht -n*n, halb);} else{
			  if ((i >= n*n/2 - acht -4) && (i < n*n/2 + acht -4))
				 {return (n - halb + yco_sqr((i-n*n/2+acht+4),halb));} else{
			   if (i >= n*n/2 - 4) {
				  return n-yco_sqr(i-n*n/2+4, n)-1;} else{
				if (2*halb == n){
				   return halb+yco_sqr(n*n/2-acht-5-i, halb);} else{
				   return halb+ycod(n*n/2-acht-5-i, n-halb);
		  }}}}}}}
    }






	//-- USED FOR CREATING RECTANGULAR GRID -----
	HCurve::Rect* HCurve::fels(int xm){
        Rect* r;
        if (bfel[xm]){
			return fel[xm];
		}else{
			r = new HCurve::Rect(); 
			fel[xm] = r; bfel[xm]=true;
			r->g=xm; r->x=xm; r->y=1; r->h=1;
			r->lo = felds(0,0); r->ro = felds(0,0);
			r->lu = felds(0,0); r->ru = felds(0,0);
			return r;
		}   
	}
    
	HCurve::Rect* HCurve::felds(int xm, int ym) {
        		
		Rect* r;
        int xn, yn;
        if (bfeld[xm][ym]) {return feld[xm][ym];} else {
			r = new HCurve::Rect(); feld[xm][ym] = r; bfeld[xm][ym]=true;
           r->x=xm; r->y=ym; xn=xm/2; yn=ym/2; r->g=xm*ym;
           if (xn==(xn/2)*2) {xn= xm -xn;};
           if (yn==(yn/2)*2) {yn= ym -yn;};
           if ((xm-xn)*(ym-yn)==0) {r->h=xm*ym-1;
            if (xm*ym==0) {r->h+=1;};
            r->lo = felds(0,0); r->ro = felds(0,0);
            r->lu = felds(0,0); r->ru = felds(0,0);
           } else {
            r->lo = felds(xn,yn); r->ro = felds(xm-xn,yn);
            r->lu = felds(xn,ym-yn); r->ru = felds(xm-xn,ym-yn);
            if (xm == 3) {
             if (2*yn != ym) {
              r->lo = fels(3); r->ro = felds(0,1);
              r->lu = felds(0,ym-1); r->ru = felds(3,ym-1);
             } else {
              if (2*(yn/2) != yn) {
               r->lo = felds(3,yn); r->ro = felds(0,yn);
               r->lu = felds(0,yn); r->ru = felds(3,yn);
              } else {
               r->lo = felds(3,yn); r->ro = felds(0,yn);
               r->lu = felds(3,yn); r->ru = felds(0,yn);
            }}} else {
             if ((xm == 2) && (2*yn == ym)) {
               r->lo = felds(2,yn); r->ro = felds(0,yn);
               r->lu = felds(0,ym-yn); r->ru = felds(2,ym-yn);
             } else {
              if ((ym == 3) && (2*xn != xm)) {
               r->lo = fels(xm); r->ro = felds(0,1);
               r->lu = felds(0,ym-1); r->ru = felds(xm,ym-1);
            }}}
            if (2*r->lo->y == ym) {r->h = r->lo->g-r->lo->h;} else {r->h = r->lo->h;};
            r->h=r->h+r->lu->g+r->ru->h;
            if ((xm == 3) && (2*(yn/2) == yn) && (2*yn == ym)) {
             r->h = r->h - r->lu->h +1;
           }}
           if ((2*r->lo->x == xm) && (2*r->lo->y != ym)) {
            r->sp = felds(ym,xm);
            r->h = r->sp->g - r->sp->h;
           }
           return r;
		}   
	}









	//####### Rectangle Class ##############################

	HCurve::Rect::Rect(){
	}

	int HCurve::Rect::xcor(int i) {
		 if (x == 1) {return 0;} else {
		  if (y == 1) {return i;} else {
		   if (2*lo->y == y) {
			 if (i < lo->g-lo->h) {return lo->x-1-lo->xcor(i+lo->h);} else {
			  if (i < lu->g+lo->g-lo->h) {
			   return lu->x-1-lu->xcor(lu->g+lo->g -lo->h -i-1);
			  } else {
			   if (i < ru->g+lu->g+lo->g-lo->h) {
				return lu->x+ru->xcor(i-lu->g-lo->g +lo->h);
			   } else {
				if (i < g-lo->h) {
				 return lo->x+ro->xcor(g -lo->h  -i-1);
				} else {
				 return lo->x-1-lo->xcor(i+lo->h-g);
		   } }}}} else {
			if (2*lo->x == x) { return sp->ycor(g-i);
			} else {
			 if (i < lo->h) {return lo->xcor(i);} else {
			  if (i < lu->g+lo->h) {
			   return lu->x-1-lu->xcor(lu->g +lo->h -i-1);
			  } else {
			   if (i < lu->g+ru->g+lo->h) {
				return lu->x+ru->xcor(i-lu->g-lo->h);
			   } else {
				if (i < g-lo->g+lo->h) {
				 return lo->x+ro->xcor(g -lo->g+lo->h  -i-1);
				} else {
				 return lo->xcor(i+lo->g-g);
		 }}}}}}}}
	   }

	int HCurve::Rect::ycor(int i) {
     if (x == 1) {return i;} else {
      if (y == 1) {return 0;} else {
       if (2*lo->y == y) {
         if (i < lo->g-lo->h) {return lo->y-1-lo->ycor(i+lo->h);} else {
          if (i < lu->g+lo->g-lo->h) {
           return lo->y+lu->ycor(lu->g+lo->g -lo->h -i-1);
          } else {
           if (i < ru->g+lu->g+lo->g-lo->h) {
            return ro->y+ru->ycor(i-lu->g-lo->g +lo->h);
           } else {
            if (i < g-lo->h) {
             return ro->y-1-ro->ycor(g -lo->h  -i-1);
            } else {
             return lo->y-1-lo->ycor(i+lo->h-g);
       } }}}} else {
        if (2*lo->x == x) { return sp->xcor(g-i);
        } else {
         if (i < lo->h) {return lo->ycor(i);} else {
          if (i < lu->g+lo->h) {
           return lo->y+lu->ycor(lu->g +lo->h -i-1);
          } else {
           if (i < lu->g+ru->g+lo->h) {
            return ro->y+ru->ycor(i-lu->g-lo->h);
           } else {
            if (i < g-lo->g+lo->h) {
             return ro->y-1-ro->ycor(g -lo->g+lo->h  -i-1);
            } else {
             return lo->ycor(i+lo->g-g);
     }}}}}}}}
   }


