#include <stdio.h>
#include "OKCFile.h"

OKCFile::OKCFile(const char* okc_filename)
{
	readsuccess=true;
	// open file
	filename = okc_filename;
	FILE *okcf = fopen(filename,"r");
	if (okcf!=NULL){
		// read file
		ReadOKCFile(okcf);
	}else{
		readsuccess=false;
	}
	// close file
	fclose(okcf);
}

// Read OKC file
void OKCFile::ReadOKCFile(FILE* okcfile)
{
	int temp,i,j;
	
	//read header
	fscanf(okcfile, "%d %d\n", &ndims, &ndata);
	if (ndims==0 || ndata==0)
		readsuccess = false;
	dim_min = new double[ndims];
    dim_max = new double[ndims];
    fac = new double[ndims];
    int ch;
	for (i=0;i<ndims;i++)
		while ( (ch = fgetc(okcfile)) != '\n' ){}
	
	for (i=0;i<ndims;i++){
        fscanf(okcfile, "%lf %lf %d \n", &dim_min[i], &dim_max[i], &temp);
        if ( fabs(dim_max[i]-dim_min[i]) > 1e-9 )
			fac[i] = 1/(dim_max[i]-dim_min[i]);
        else
			fac[i] = 1;
    }

	//read data
	dataset = new double*[ndata];
	for (i=0;i<ndata;i++){
		dataset[i] = new double[ndims];
		for (j=0;j<ndims;j++){
			fscanf(okcfile, "%lf", &value);
			//if (binary)
				dataset[i][j] = value ;
			//else
			//	dataset[i][j] = (value-dim_min[j]) * fac[j];
		}
	}	
}

// print dataset (for testing purposes only)
void OKCFile::Print()
{
    int i, j;
	// print min
	for (j=0;j<ndims;j++)
		cout << dim_min[j] << ",";
	cout << endl;
	// print max
	for (j=0;j<ndims;j++)
		cout << dim_max[j] << ",";
	cout << endl;
	// print data
	for (i=0;i<ndata;i++){
		for (j=0;j<ndims;j++)
			cout << dataset[i][j] ;
		cout << endl;
	}
	
}






