#ifndef SlowCluster_H
#define SlowCluster_H

#include "../../basic/CLinkList.h"
#include "../../basic/macros.h"


struct DataPair{
	CLinkListNode *p1, *p2;
    DataPair(CLinkListNode *pointer1, CLinkListNode *pointer2) : p1(pointer1), p2(pointer2) {}
};

struct ClusterNode{
    int id;
    int entries;
    int itemID;
    int count;
	IIHash *itemHash;
  	CLinkListNode *parent;
    ClusterNode() 
    {
        itemID = -1;
        count = 0;
        itemHash = new IIHash();
    }
    ~ClusterNode() 
    {
        delete itemHash;
    }
};

class SlowClustering
{
protected:
    double **covs;
    int size;

private:
    CLinkList* GetInput(FILE *fp);
    CLinkListNode* WhoIsMaximum( CLinkList *data_link );
    void Clustering(CLinkList *data_link1, CLinkList *data_link2, double min_distance);
    void WriteOutput(FILE *fp, CLinkList* data_link);
    bool OnlineCluster(const char* cov_file_name, const char* cg_file_name, int times);
    double GetDistance(IIHash* hash1, IIHash* hash2);

public:
    SlowClustering(const char* cov_file_name, int repeat_times);
};

#endif