//RGB class that stores a color in the R(ed), G(reen), B(lue), A(lpha) format 

#ifndef RGB_H
#define RGB_H

struct RGBt {
    float R,G,B,A;

    RGBt(void) : R(1.), G(1.), B(1.), A(1.) {}

    RGBt(float r,float g,float b, float a = 1.) 
		: R(r), G(g), B(b), A(a) {}

    RGBt(const unsigned long &c) {
        B = (c & 0xFF)/255.f;
        G = ((c>>8) & 0xFF)/255.f;
        R = ((c>>16) & 0xFF)/255.f;
		A = ((c>>24) & 0xFF)/255.f;
    }

	unsigned long GetColor() const {
		return ( ((unsigned long)( 255. * B))       |
				 ((unsigned long)( 255. * G)) << 8  |
				 ((unsigned long)( 255. * R)) << 16 |
				 ((unsigned long)( 255. * A)) << 24 );
	}

};

#endif