//2D vector class defined by the system 

#ifndef Vec3_H
#define Vec3_H

#include <math.h>
//#include <iostream>

class Vec3
{
    public:
        Vec3(double x=0, double y=0, double z = 0) :
            X(x), Y(y), Z(z)
        {}

        double operator[](int i) const { return ((double*)&X)[i]; }
        double &operator[](int i) { return ((double*)&X)[i]; }
//        friend Vec3 operator-(const Vec3 &v1, const Vec3 &v2); 
        friend Vec3 operator+(const Vec3 &v1, const Vec3 &v2); 
        friend double operator*( const Vec3 & v1, const Vec3& v2);
        friend Vec3 operator*( double x, const Vec3& v2);
        
//        friend std::ostream &operator<<(std::ostream &out, const Vec3& v);
                
        double norm() const;
        void normalize();
        void Set(double x,double y, double z) { X=x; Y=y; Z=z;}
        
    public:
        double X,Y,Z;
};

inline Vec3 operator- (const Vec3 &v1, const Vec3 &v2 )
{
    return Vec3(v1.X - v2.X, v1.Y - v2.Y, v1.Z - v2.Z );
}

inline Vec3 operator+ (const Vec3 &v1, const Vec3 &v2 )
{
    return Vec3(v1.X + v2.X, v1.Y + v2.Y, v1.Z + v2.Z);
}

/*inline std::ostream &operator<<(std::ostream &out, const Vec3 &v)
{
    out << " [ " << v.X << " " << v.Y << " ] ";
    return out;
}
*/

inline double Vec3::norm() const 
{
    return sqrt(X*X + Y*Y + Z*Z);
}

inline void Vec3::normalize()
{
    double mag = norm();
    X /= mag;
    Y /= mag;
    Z /= mag;
}

inline double operator*( const Vec3 &v1, const Vec3 &v2)
{
    return v1.X*v2.X + v1.Y*v2.Y + v1.Z * v2.Z;
}

inline Vec3 operator*( double x, const Vec3 &v2)
{
    return Vec3( x*v2.X, x*v2.Y, x * v2.Z );
}

#endif
