#include "ColorManager.h"
#include "Basic/macros.h"


ColorManager::ColorManager()
{
    settingNum = TOTAL_COLOR_SETTING_NUM;
    colorSettings = new ColorSetting * [settingNum];
    for(int i = 0; i < settingNum; i++)
    {
        colorSettings[i] = new ColorSetting();
    }

    SetTheme(ORIGINAL);
}	

ColorManager::~ColorManager()
{
    for (int i = 0; i < settingNum; i++)
    {
        delete colorSettings[i];
    }
    delete [] colorSettings;

}

void ColorManager::SetTheme(Theme theme)
{
    colorSettings[SBB]->SetColorScale(ColorSetting::SBB_COLOR);
    
    colorSettings[CATEGORY+0]->SetColor(RGBt(0xff61f369));
    colorSettings[CATEGORY+1]->SetColor(RGBt(0xfff20000));
    colorSettings[CATEGORY+2]->SetColor(RGBt(0xfff2f200));
    colorSettings[CATEGORY+3]->SetColor(RGBt(0xff00f2f2));
    colorSettings[CATEGORY+4]->SetColor(RGBt(0xff0000f2));
    colorSettings[CATEGORY+5]->SetColor(RGBt(0xffe2ffff));
    colorSettings[CATEGORY+6]->SetColor(RGBt(0xffffe2ff));
    colorSettings[CATEGORY+7]->SetColor(RGBt(0xffffffe2));
    colorSettings[CATEGORY+8]->SetColor(RGBt(0xffaaffaa));
    colorSettings[CATEGORY+9]->SetColor(RGBt(0xffaaaaaa));
    
/*    colorSettings[NUERIC+0]->SetColor(RGBt(0xffffffe5));
    colorSettings[NUERIC+1]->SetColor(RGBt(0xfffff7bc));
    colorSettings[NUERIC+2]->SetColor(RGBt(0xfffee391));
    colorSettings[NUERIC+3]->SetColor(RGBt(0xfffec44f));
    colorSettings[NUERIC+4]->SetColor(RGBt(0xfffe9929));
    colorSettings[NUERIC+5]->SetColor(RGBt(0xffec7014));
    colorSettings[NUERIC+6]->SetColor(RGBt(0xffcc4c02));
    colorSettings[NUERIC+7]->SetColor(RGBt(0xff993404));
    colorSettings[NUERIC+8]->SetColor(RGBt(0xff662506));
    colorSettings[NUERIC+9]->SetColor(RGBt(0xffe31a1c));
*/

    colorSettings[NUERIC+9]->SetColor(RGBt(0xffa50026));
    colorSettings[NUERIC+8]->SetColor(RGBt(0xffd73027));
    colorSettings[NUERIC+7]->SetColor(RGBt(0xfff46d43));
    colorSettings[NUERIC+6]->SetColor(RGBt(0xfffdae61));
    colorSettings[NUERIC+5]->SetColor(RGBt(0xfffee08b));
    colorSettings[NUERIC+4]->SetColor(RGBt(0xffd9ef8b));
    colorSettings[NUERIC+3]->SetColor(RGBt(0xffa6d96a));
    colorSettings[NUERIC+2]->SetColor(RGBt(0xff66bd63));
    colorSettings[NUERIC+1]->SetColor(RGBt(0xff1a9850));
    colorSettings[NUERIC+0]->SetColor(RGBt(0xff006837));

    if (theme == ORIGINAL)
    {
        colorSettings[BG]->SetColor(RGBt(0xffffffff));
        colorSettings[LABEL]->SetColor(RGBt(0xff000000));
        colorSettings[FLAT_UNBRUSHED_DATA]->SetColor(RGBt(0xff61f369));
        colorSettings[OVERLAP]->SetColor(RGBt(0xff000000));
        colorSettings[PAINT]->SetColor(RGBt(0xff980098));
        colorSettings[HIER_BRUSHED_DATA]->SetColor(RGBt(0xffff7138));
        
        colorSettings[GRID+0]->SetColor(RGBt(0xffe31a1c));
        colorSettings[GRID+1]->SetColor(RGBt(0xff377db8));
        colorSettings[GRID+2]->SetColor(RGBt(0xff4daf4a));
        colorSettings[GRID+4]->SetColor(RGBt(0xff984ea3));
        colorSettings[GRID+5]->SetColor(RGBt(0xffff7f00));
        colorSettings[GRID+6]->SetColor(RGBt(0xffffff33));
        colorSettings[GRID+7]->SetColor(RGBt(0xffa65628));
        colorSettings[GRID+8]->SetColor(RGBt(0xfff781bf));
        colorSettings[GRID+9]->SetColor(RGBt(0xff999999));
        
        colorSettings[BRUSH+0]->SetColor(RGBt(0xffb3e2cd));
        colorSettings[BRUSH+1]->SetColor(RGBt(0xfffdcdac));
        colorSettings[BRUSH+2]->SetColor(RGBt(0xffcbd5e8));
        colorSettings[BRUSH+3]->SetColor(RGBt(0xfff4cae4));
        
/*        colorSettings[BRUSH+0]->SetColor(RGBt(0xffafafea));
        colorSettings[BRUSH+1]->SetColor(RGBt(0xffafafaf));
        colorSettings[BRUSH+2]->SetColor(RGBt(0xffafaf75));
        colorSettings[BRUSH+3]->SetColor(RGBt(0xffafaf3a));
*/        
        colorSettings[STAT+0]->SetColor(RGBt(0xff0000ea));
        colorSettings[STAT+1]->SetColor(RGBt(0xffc30000));
        
        colorSettings[HIGHLIGHT+0]->SetColor(RGBt(0xfff20000));
        colorSettings[HIGHLIGHT+1]->SetColor(RGBt(0xfff2f200));
        colorSettings[HIGHLIGHT+2]->SetColor(RGBt(0xff00f2f2));
        colorSettings[HIGHLIGHT+3]->SetColor(RGBt(0xff0000f2));
        colorSettings[HIGHLIGHT+4]->SetColor(RGBt(0xffe2ffff));
        colorSettings[HIGHLIGHT+5]->SetColor(RGBt(0xffffe2ff));
        colorSettings[HIGHLIGHT+6]->SetColor(RGBt(0xffffffe2));
        colorSettings[HIGHLIGHT+7]->SetColor(RGBt(0xffaaffaa));
    }
    else if (theme == NOCTURNAl)
    {
        colorSettings[BG]->SetColor(RGBt(0xff000000));
        colorSettings[LABEL]->SetColor(RGBt(0xfffefe00));
        colorSettings[FLAT_UNBRUSHED_DATA]->SetColor(RGBt(0xff98f298));
        colorSettings[OVERLAP]->SetColor(RGBt(0xff000000));
        colorSettings[PAINT]->SetColor(RGBt(0xff980098));
        colorSettings[HIER_BRUSHED_DATA]->SetColor(RGBt(0xfff6a430));
        
        colorSettings[GRID+0]->SetColor(RGBt(0xfffe5c5e));
        colorSettings[GRID+1]->SetColor(RGBt(0xff0fff0f));
        colorSettings[GRID+2]->SetColor(RGBt(0xff0f0fff));
        colorSettings[GRID+3]->SetColor(RGBt(0xff0f0fff));
        
        colorSettings[BRUSH+0]->SetColor(RGBt(0xffafafea));
        colorSettings[BRUSH+1]->SetColor(RGBt(0xffafafaf));
        colorSettings[BRUSH+2]->SetColor(RGBt(0xffafaf75));
        colorSettings[BRUSH+3]->SetColor(RGBt(0xffafaf3a));
        
        colorSettings[STAT+0]->SetColor(RGBt(0xff0000ea));
        colorSettings[STAT+1]->SetColor(RGBt(0xffc30000));
        
        colorSettings[HIGHLIGHT+0]->SetColor(RGBt(0xfff20000));
        colorSettings[HIGHLIGHT+1]->SetColor(RGBt(0xfff2f200));
        colorSettings[HIGHLIGHT+2]->SetColor(RGBt(0xff00f2f2));
        colorSettings[HIGHLIGHT+3]->SetColor(RGBt(0xff0000f2));
        colorSettings[HIGHLIGHT+4]->SetColor(RGBt(0xffe2ffff));
        colorSettings[HIGHLIGHT+5]->SetColor(RGBt(0xffffe2ff));
        colorSettings[HIGHLIGHT+6]->SetColor(RGBt(0xffffffe2));
        colorSettings[HIGHLIGHT+7]->SetColor(RGBt(0xffaaffaa));
    }
    else if (theme == GRAYS)
    {
        colorSettings[BG]->SetColor(RGBt(0xffffffff));
        colorSettings[LABEL]->SetColor(RGBt(0xff000000));
        colorSettings[FLAT_UNBRUSHED_DATA]->SetColor(RGBt(0xff000000));
        colorSettings[OVERLAP]->SetColor(RGBt(0xff000000));
        colorSettings[PAINT]->SetColor(RGBt(0xff980098));
        colorSettings[HIER_BRUSHED_DATA]->SetColor(RGBt(0xfff6a430));
        
        colorSettings[GRID+0]->SetColor(RGBt(0xff000000));
        colorSettings[GRID+1]->SetColor(RGBt(0xff0fff0f));
        colorSettings[GRID+2]->SetColor(RGBt(0xff0f0fff));
        colorSettings[GRID+3]->SetColor(RGBt(0xff0f0f0f));
        
        colorSettings[BRUSH+0]->SetColor(RGBt(0xffdadada));
        colorSettings[BRUSH+1]->SetColor(RGBt(0xffafafaf));
        colorSettings[BRUSH+2]->SetColor(RGBt(0xffafaf75));
        colorSettings[BRUSH+3]->SetColor(RGBt(0xffd8d69e));
        
        colorSettings[STAT+0]->SetColor(RGBt(0xfffefefe));
        colorSettings[STAT+1]->SetColor(RGBt(0xfffefefe));
        
        colorSettings[HIGHLIGHT+0]->SetColor(RGBt(0xfffe0000));
        colorSettings[HIGHLIGHT+1]->SetColor(RGBt(0xfffefe00));
        colorSettings[HIGHLIGHT+2]->SetColor(RGBt(0xff00fefe));
        colorSettings[HIGHLIGHT+3]->SetColor(RGBt(0xff0000fe));
        colorSettings[HIGHLIGHT+4]->SetColor(RGBt(0xffe2ffff));
        colorSettings[HIGHLIGHT+5]->SetColor(RGBt(0xffffe2ff));
        colorSettings[HIGHLIGHT+6]->SetColor(RGBt(0xffffffe2));
        colorSettings[HIGHLIGHT+7]->SetColor(RGBt(0xffaaffaa));
    }
    else if (theme == MIDNIGHT_BLUE)
    {
        colorSettings[BG]->SetColor(RGBt(0xff000096));
        colorSettings[LABEL]->SetColor(RGBt(0xfffffefe));
        colorSettings[FLAT_UNBRUSHED_DATA]->SetColor(RGBt(0xffeaeca0));
        colorSettings[OVERLAP]->SetColor(RGBt(0xff000000));
        colorSettings[PAINT]->SetColor(RGBt(0xff980098));
        colorSettings[HIER_BRUSHED_DATA]->SetColor(RGBt(0xfff6a430));
        
        colorSettings[GRID+0]->SetColor(RGBt(0xfffffefe));
        colorSettings[GRID+1]->SetColor(RGBt(0xff0fff0f));
        colorSettings[GRID+2]->SetColor(RGBt(0xff0f0fff));
        colorSettings[GRID+3]->SetColor(RGBt(0xff0000ea));
        
        colorSettings[BRUSH+0]->SetColor(RGBt(0xff8e3014));
        colorSettings[BRUSH+1]->SetColor(RGBt(0xffafafaf));
        colorSettings[BRUSH+2]->SetColor(RGBt(0xffafaf75));
        colorSettings[BRUSH+3]->SetColor(RGBt(0xffd8d69e));
        
        colorSettings[STAT+0]->SetColor(RGBt(0xff0000ea));
        colorSettings[STAT+1]->SetColor(RGBt(0xffc30000));
        
        colorSettings[HIGHLIGHT+0]->SetColor(RGBt(0xff28d320));
        colorSettings[HIGHLIGHT+1]->SetColor(RGBt(0xff00d320));
        colorSettings[HIGHLIGHT+2]->SetColor(RGBt(0xff28d320));
        colorSettings[HIGHLIGHT+3]->SetColor(RGBt(0xff28d320));
        colorSettings[HIGHLIGHT+4]->SetColor(RGBt(0xffe2ffff));
        colorSettings[HIGHLIGHT+5]->SetColor(RGBt(0xffffe2ff));
        colorSettings[HIGHLIGHT+6]->SetColor(RGBt(0xffffffe2));
        colorSettings[HIGHLIGHT+7]->SetColor(RGBt(0xffaaffaa));
    }
    else if (theme == SEA_GREEN)
    {
        colorSettings[BG]->SetColor(RGBt(0xff48b000));
        colorSettings[LABEL]->SetColor(RGBt(0xfffefbfe));
        colorSettings[FLAT_UNBRUSHED_DATA]->SetColor(RGBt(0xff5155fe));
        colorSettings[OVERLAP]->SetColor(RGBt(0xff000000));
        colorSettings[PAINT]->SetColor(RGBt(0xff980098));
        colorSettings[HIER_BRUSHED_DATA]->SetColor(RGBt(0xfff6a430));
        
        colorSettings[GRID+0]->SetColor(RGBt(0xff000000));
        colorSettings[GRID+1]->SetColor(RGBt(0xff0fff0f));
        colorSettings[GRID+2]->SetColor(RGBt(0xff0f0fff));
        colorSettings[GRID+3]->SetColor(RGBt(0xff0f0fff));
        
        colorSettings[BRUSH+0]->SetColor(RGBt(0xff806260));
        colorSettings[BRUSH+1]->SetColor(RGBt(0xffafafaf));
        colorSettings[BRUSH+2]->SetColor(RGBt(0xffafaf75));
        colorSettings[BRUSH+3]->SetColor(RGBt(0xffd8d69e));
        
        colorSettings[STAT+0]->SetColor(RGBt(0xfffefefe));
        colorSettings[STAT+1]->SetColor(RGBt(0xfffefefe));
        
        colorSettings[HIGHLIGHT+0]->SetColor(RGBt(0xfffffa66));
        colorSettings[HIGHLIGHT+1]->SetColor(RGBt(0xff00d320));
        colorSettings[HIGHLIGHT+2]->SetColor(RGBt(0xff28d320));
        colorSettings[HIGHLIGHT+3]->SetColor(RGBt(0xff28d320));
        colorSettings[HIGHLIGHT+4]->SetColor(RGBt(0xffe2ffff));
        colorSettings[HIGHLIGHT+5]->SetColor(RGBt(0xffffe2ff));
        colorSettings[HIGHLIGHT+6]->SetColor(RGBt(0xffffffe2));
        colorSettings[HIGHLIGHT+7]->SetColor(RGBt(0xffaaffaa));
    }

}

ColorSetting* ColorManager::GetColorSetting(int type, int id)
{
    return colorSettings[type+id];
}

void ColorManager::InvertColors()
{
    for (int i = 0; i < settingNum; i++)
        colorSettings[i]->InvertColor();
}

bool ColorManager::IsSingleColor(int type, int id)
{
    return colorSettings[type+id]->IsSingleColor();
}

/*
RGBt ColorManager::GetColor(int type, int id, ARR<double> values)
{
    return colorSettings[type+id]->GetColor(values);
}*/

RGBt ColorManager::GetColor(int type, int id)
{
    return colorSettings[type+id]->GetColor();
}

RGBt ColorManager::GetColor(int type, int id, float value)
{
    return colorSettings[type+id]->GetColor(value);
}

void ColorManager::SetColor(int type, int id, RGBt color)
{
    colorSettings[type+id]->SetColor(color);
}

/*
void ColorManager::SetColorScale(int type, int id, ColorSetting::ColorScale scale)
{
    colorSettings[type+id]->SetColorScale(scale);
}*/


