#include <stdio.h>
#include <iostream>
#include "statement.h"
#include "odbc.h"
#include "ResultSet.h"

/**
* Constrcuts a new SQL statement , Note this can be
* constructed only by the connection class
* \param sqlStatement 
* \return 
*/
Statement ::Statement(otl_connect* otlConnectPtr)
{	
	this->otlConnectPtr = otlConnectPtr;
	this->stream = NULL;
}


/**
* This executes the query and returns the result in the 
* Result Set.
* \param sqlStatement 
* @post the caller should take care of deleting the result set.
* \return 
*/
ResultSet* Statement :: executeQuery(std::string sqlStatement)
{
	try{
	
	this->stream = new otl_stream(1000,// buffer size
									   sqlStatement.c_str(),// SELECT statement		
									   *(this->otlConnectPtr)); // connect object		
	return(new ResultSet(stream));
	}catch(otl_exception& p){ // intercept OTL exceptions
		std::cerr<<p.msg<<std::endl; // print out error message
		std::cerr<<p.stm_text<<std::endl; // print out SQL that caused the error
		std::cerr<<p.sqlstate<<std::endl; // print out SQLSTATE message
		std::cerr<<p.var_info<<std::endl; // print out the variable that caused the error
		return(0);
	}
}

/**
* This executes the query
* \param query 
* \return bool, true if the query was succcessfully executed.
* or else throws an exception
*/
bool Statement ::execute(std::string query)
{
	int count = otl_cursor::direct_exec
		(
		*(this->otlConnectPtr),
		query.c_str(),
		otl_exception::enabled
		); 
//	std::cout<<"The number of rows inserted :"<<count;
	return(true);
}


/**
* Destroys an SQL statement.
* \return 
*/
Statement::~Statement(void)
{		
}
