#ifndef _STATEMENT_H 
#define _STATEMENT_H 

#include <string>



//Forward References
class ResultSet;
class otl_connect;
class otl_stream;

class Statement
{

friend 
	class Connection;

private:
	/**
	* Constrcuts a new SQL statement , Note this can be
	* constructed only by the connection class
	* \param sqlStatement 
	* \return 
	*/
	Statement(otl_connect* otlConnectPtr);
	

public:

	/**
	* This executes the query and returns the result in the 
	* Result Set.
	* \param sqlStatement 
	* \return 
	*/
	ResultSet* executeQuery(std::string sqlStatement);

	/**
	* This executes the query
	* \param query 
	* \return bool, true if the query was succcessfully executed.
	*/
	bool execute(std::string query);
	
	/**
	* Destroys an SQL statement.
	* \return 
	*/
	~Statement();

private:
	//Stores the reference to the connect object
	otl_connect *otlConnectPtr;
	//Stores the pointer to the current stream
	otl_stream *stream;
	//Stores the current sql statement
	std::string currSqlStatement;
};


#endif