#ifndef DB_Column_ITERATOR_H
#define DB_Column_ITERATOR_H

#include "Basic/Iterator.h"
#include "DataStructure/DocColumn.h"
#include "DataStructure/Query.h"
#include "DBConnection/DBManager.h"
#include "../../DocumentManager.h"

union Data;
class DataBuffer;
struct RGBt;
class DimensionManager;
class DBManager;

enum {
    GROUP_MODE = 1,
    NORMAL_MODE = 2,
    MASK_MODE = 5,

    ONE_DIM_MODE = 3,
    TWO_DIM_MODE = 4,
    THREE_DIM_MODE = 5,

};

class DBColumnIterator : public Iterator
{
protected:
    DBManager* dbManager;
    std::string dataTableName;
    DimensionSpace *loadDimSpace;
    DimensionSpace *allDimSpace;
    int rowNum;
    Query* query;

    int queryMode, groupingMode;
    int isMaskable;
    bool sampling;
    int samplingMode;
    int approximateSize;
    bool isIncreasingOrder; 

    bool noquery; //if this is true, no need to send query to database
    int columnSize; //when sampling is false, columnsize is equal to rowNum. Elsewise less or equal.  
    int loadDimNum;
    int count;

    double **buffer;
    DocColumn* docColumn;

public:
    DBColumnIterator(DBManager* dbManager, std::string dataTableName, DimensionSpace* allDimSpace, DimensionSpace* loadDimSpace, 
             int rowNum, Query* query);
    ~DBColumnIterator();

    void* GetNext();
	bool IsDone();

protected:
    int GetRandomSamplingColumnSize();
    int GetBiasedSamplingColumnSize();

    bool LoadColumnsInNormalMode();
    bool LoadColumnsInGroupMode();
    int GetColumnSizeInNormalMode();
    int GetColumnSizeInGroupMode();
};

#endif
