#include <stdio.h>
#include "DataBuffer.h"


DataBuffer::DataBuffer(int columns, int rows)
{
	if (rows > 0 && columns > 0)
	{
		this->rows = rows;
		this->columns = columns;
		this->size = rows * columns;
		buffer = new Data[size];
		columnTypes = new DataType[columns];

		for (int i = 0; i < columns; i++)
			columnTypes[i] = DOUBLE_TYPE;
	}
}	

DataBuffer::~DataBuffer()
{
	if (rows > 0 && columns > 0)
	{
		delete [] buffer;
		delete [] columnTypes;
	}
}

void DataBuffer::ResetInputCounter(int i)
{
    inputCounter = i;
}


void DataBuffer::GetInput(double data)
{
    buffer[inputCounter].d = data;
    inputCounter ++;
}

void DataBuffer::GetInput(void* pointer)
{
    buffer[inputCounter].p = pointer;
    inputCounter ++;
}

Data* DataBuffer::GetRow(int rowID)
{
	if (rowID >= rows)
		return NULL;

	return &(buffer[rowID * columns]);
}

/*
bool DataBuffer::SetColumnType(int columnID, DataType type)
{
	if (columnID >= columns)
		return false;

	columnTypes[columnID] = type;
	return true;
}

bool DataBuffer::SetData(int rowID, int columnID, Data data)
{
	if (rowID >= rows || columnID >= columns)
		return false;

	buffer[rowID*columns+columnID] = data;
	return true;
}

bool DataBuffer::SetData(int totalID, Data data)
{
	if (totalID >= size)
		return false;

	buffer[totalID] = data;
	return true;
}


DataBufferIterator* DataBuffer::GetRow(int rowID)
{
	if (rowID >= rows)
		return NULL;

	return (new DataBufferIterator(this, rowID * columns, 1));
}*/


/*
DataBufferIterator* DataBuffer::GetColumn(int columnID)
{
	if (columnID >= columns)
		return NULL;

	return (new DataBufferIterator(this, columnID, columns));
}

DataType DataBuffer::GetColumnType(int columnID)
{
	if (columnID >= columns)
		return NONE;

	return columnTypes[columnID];
}
*/
int DataBuffer::GetBufferSize()
{
    return rows * columns;
}

int DataBuffer::GetRowNum()
{
    return rows;
}