#ifndef DATABUFFER_H
#define DATABUFFER_H

#include <memory.h>
#include "DataBufferIterator.h"

union Data    // Declare union type
{
public:
   char*  s;
   int    i;
   long   l;
   float  f;
   double d;
   void*  p;

public: 
	void operator=(Data e) { memcpy(this, &e, sizeof(Data)); } 
}; 

enum DataType 
{
	STRING_TYPE,  //char*
	INT_TYPE,  //int
	LONG_TYPE,  //long
	FLOAT_TYPE,  //float
	DOUBLE_TYPE,  //double
	POINTER_TYPE,   //void*
    NONE
};

//an instance of this class contains rowsXcolumns Data 
//instances. Data in the same columns have the same DataType.
class DataBuffer
{
public:
	int rows;
	int columns;
    int size;

    DataType* columnTypes;
	Data* buffer;

    int inputCounter;

public: 
	DataBuffer(int rows, int colunms);
	~DataBuffer();
	
/*	bool SetColumnType(int columnID, DataType type);
	bool SetData(int rowID, int columnID, Data data);
	bool SetData(int totalID, Data data);
    DataBufferIterator* GetRow(int rowID);
    DataBufferIterator* GetColumn(int columnID);
	DataType GetColumnType(int columnID);
*/
    int GetBufferSize();
    int GetRowNum();

    void ResetInputCounter(int i);
    void GetInput(double data);
    void GetInput(void* pointer);
    Data* GetRow(int rowID);

};



#endif

