#include <stdio.h>
#include "DataBuffer.h"


DataBufferIterator::DataBufferIterator(
	DataBuffer* dataBuffer, int startPosition, int interval)
{
	this->dataBuffer = dataBuffer;
	this->startPosition = startPosition;
    this->interval = interval;

    bufferSize = dataBuffer->GetBufferSize();

    nextPosition = startPosition;
}	

DataBufferIterator:: ~DataBufferIterator()
{
}


void* DataBufferIterator::GetNext()
{
	if (nextPosition >= bufferSize)
		return NULL;

	Data* data = &(dataBuffer->buffer[nextPosition]);

    nextPosition += interval;

    return data;
}


bool DataBufferIterator::IsDone()
{
	if (nextPosition >= bufferSize)
		return true;
	else
		return false;
}


