#include "DocAxes.h"

DocAxes::DocAxes(DimensionSpace *dimSpace, bool dimXYNeeded, bool itemXYNeeded, IPHash* dimXYPosHash, IPHash* itemXYPosHash, IIHash* selectedDimHash, IIHash* selectedItemHash, IIHash* selectedBinHash, IIHash *labelDimHash)
{
    this->dimSpace = dimSpace;
    this->dimXYNeeded = dimXYNeeded;
    this->itemXYNeeded = itemXYNeeded;
    this->dimXYPosHash = dimXYPosHash;
    this->itemXYPosHash = itemXYPosHash;
    this->selectedDimHash = selectedDimHash;
    this->selectedItemHash = selectedItemHash;
    this->selectedBinHash = selectedBinHash;
    this->labelDimHash = labelDimHash;
}

DocAxes:: ~DocAxes()
{
}

/*
Vec2 DocAxes::GetDimensionXYPosition(int dimID)
{
    if (dimXYNeeded)
    {
        Vec2 *p = ((Vec2 *)((*dimXYPosHash)[dimID]));
        return *p;
     }
    else 
        return Vec2(0, 0);
}*/

/*
Vec2 DocAxes::GetItemXYPosition(int itemID)
{
    if (itemXYNeeded)
    {
        Vec2 *p = ((Vec2 *)((*itemXYPosHash)[itemID]));
        return *p;
    }
    else 
        return Vec2(0, 0);
}*/

int DocAxes::GetDimenionNum()
{
    return dimSpace->GetSize();
}

//get the dimension ID of the nth dimension in the dimensionspace represented by the axes
int DocAxes::GetDimensionID(int n)
{
    return dimSpace->GetDimension(n)->GetDimensionID();
}

bool DocAxes::IsLeafDimension(int dimID)
{
    return dimSpace->GetDimension(dimID)->IsLeafDimension();
}

//dis of this dim with next dim
double DocAxes::GetDimensionDistance(int dimID)
{
    int dimID2;
    if (dimID == dimSpace->GetSize()-1)
        dimID2 = 0;
    else
        dimID2 = dimID +1;

    return GetDimensionDistance(dimID, dimID2);
}

double DocAxes::GetDimensionDistance(int dimID1, int dimID2)
{
    return dimSpace->GetDimensionDistance(dimID1, dimID2);
}

double DocAxes::GetNorValueForColor(int dimID)
{
    if (IsLeafDimension(dimID))
        return 1.0;
    return 0; //to be done
}

double DocAxes::GetWidth(int dimID)
{
    if (IsLeafDimension(dimID))
        return 1.0;
    else
        return 0.5;//to be done
}