#ifndef _DOC_AXES_H
#define _DOC_AXES_H

#include "DocElement.h"
#include "DimensionSpace.h"
#include "../Basic/macros.h"
#include "../Basic/Vec2.h"

class DocAxes : public DocElement
{
protected:
    DimensionSpace* dimSpace;
    bool dimXYNeeded;
    bool itemXYNeeded;
    IPHash* dimXYPosHash;
    IPHash* itemXYPosHash;
    IIHash* selectedItemHash;
    IIHash* selectedBinHash;
    IIHash* selectedDimHash;
    IIHash* labelDimHash;

public: 
    DocAxes(DimensionSpace *dimSpace, bool dimXYNeeded, bool itemXYNeeded, IPHash* dimXYPosHash, IPHash* itemXYPosHash, IIHash* selectedDimHash, IIHash* selectedItemHash, IIHash* selectedBinHash, IIHash *labelDimHash);
	~DocAxes();

    int GetDimenionNum();
    bool IsLeafDimension(int dimID);
    double GetDimensionDistance(int dimID); //dis of this dim with next dim
    double GetDimensionDistance(int dimID1, int dimID2);
    double GetNorValueForColor(int dimID);
    double GetWidth(int dimID);
    int GetDimensionID(int n);
//   Vec2 GetDimensionXYPosition(int dimID);
//    Vec2 GetItemXYPosition(int itemID);
    IPHash* GetDimensionXYPosHash(){return dimXYPosHash;}
    IPHash* GetItemXYPosHash(){return itemXYPosHash;}
    IIHash* GetSelectedItemHash() {return selectedItemHash;}
    IIHash* GetSelectedBinHash() {return selectedBinHash;}
    IIHash* GetSelectedDimensionHash() {return selectedDimHash;}
    IIHash* GetLabelDimensionHash() {return labelDimHash;}
    DimensionSpace* GetDimensionSpace() {return dimSpace;}
};

#endif

