//Here, Column means a column in a table, namely a dimension. 

#ifndef DocColumn_H
#define DocColumn_H

#include "DocElement.h"
#include "DimensionSpace.h"
#include "Cluster.h"

enum{
    SINGLE,
    DUAL,
    TRIPLE,
    FOUR,
};

class DocColumn : public DocElement
{
protected:
    bool notLoad; //if notLoad is true, then the data stored is meaningless and should not be used
    int size;
    float* data;
    float* baseData;
    float* xData;
    float* yData;
    float* maskData;
    int* itemIDs;

	int dimID;

    int mode;
    bool maskMode;

public: 
    DocColumn();
	~DocColumn();

    void SetMode(int mode) {this->mode = mode;}
    void SetMaskMode(bool mode) {maskMode = mode;}
    bool IsMaskMode() {return maskMode;}
    bool SetSize(int size);  //if size > 0, reture true, else, false
    void SetNotLoad(bool notLoad);
    void SetData(int i, double data);
    void SetBaseData(int i, double data);
    void SetXData(int i, double data);
    void SetYData(int i, double data);
    void SetItemID(int i, int data);
    void SetMaskData(int i, double data);
	void SetDimensionID(int ID) {dimID = ID;}
	int GetDimensionID() {return dimID;}
    
    float* GetData();
    float* GetBaseData();
    float* GetXData();
    float* GetYData();
    int* GetItemIDs();
    float* GetMaskData();
    int GetSize();
    bool NotLoad();
    int GetMode();

};



#endif

