//Here, Data means a row in a table, namely a data item. 

#ifndef DocData_H
#define DocData_H

#include "DocElement.h"
#include "DimensionSpace.h"
#include "Cluster.h"

struct RGBt;


class DocRow : public DocElement
{
protected:
    bool notLoad; //if notLoad is true, then the data stored is meaningless and should not be used
    DimensionSpace* dimSpace;
    int dimNum;
    bool* isLeafDim;
//    double* norValueForColor();
//    double* norValueForWidth();


    int* card;
    bool dataCluster;
    bool dimCluster;
    double *** norValues;
    double norValueForColor; //sometime color of a data item is decided by the value of it in some dimension. 
    int num1, num2;

    bool originalDataItem; //this value differenciate data cluster and single data item

    int itemID;

    std::string description;

    /* 
    int descriptiveNum;
    void** descriptiveValues;
    double coverage;
    */

public: 
//    DocRow(int dimNum, bool extents = false, int valuesForColorNum = 0, int descriptiveNum = 0);
    DocRow(DimensionSpace* dimSpace, bool dataCluster, bool dimCluster);
	~DocRow();

    double GetNorValue(int dataClusterType, int dimClusterType, int dimID);
    void SetNorValue(int dataClusterType, int dimClusterType, int dimID, double value);
    void SetCard(int dimID, int value);
    int GetCard(int dimID);
    double GetNorValueForColor();
    void ResetData(Data* data);
    void ResetCards(Data* data);
    void ResetData(Cluster* cluster);

    void SetOriginalDataItem(bool original);
    bool IsOriginalDataItem();

    void SetItemID(int id) {itemID = id;}
    int GetItemID() {return itemID;}

    void SetNotLoad(bool notLoad) {this->notLoad = notLoad;}
    bool NotLoad() {return notLoad;}

    void SetItemDescription(std::string des) {description = des;}
    std::string GetItemDescription() {return description;}
/*    void SetNorAverages(double* norAverages);
	void SetNorMaxes(double* norMaxes);
	void SetNorMins(double* norMins);
	void SetNorValuesForColor(double* value);
    void SetCoverage(double coverage);
*/
//    void GetNorValues(ARR<double> &norValues);
/*	void GetNorMaxes(ARR<double> &norMaxes);
	void GetNorMins(ARR<double> & norMins);
	void GetNorValuesForColor(ARR<double> &norValuesForColor);
    void GetCoverage(double &coverage);
*/
/*	void SetID(nextPosition);
    void SetCoverage(coverages[nextPosition]);
    void SetDataSpace(DimensionSpace* dataSpace);
    void SetColorSpace(DimensionSpace* colorSpace);
*/
};



#endif

