#ifndef HierDataSet_H
#define HierDataSet_H

#include "../basic/Iterator.h"
#include "DimensionSpace.h"
#include "SBBrush.h"
#include "SBBContourNode.h"

class SBBrush;

class HierDataSet
{
protected:
    SBBrush* sbBrush;
    int maxLevel;

public: 
	HierDataSet();
	virtual ~HierDataSet();

/*	virtual Iterator* LoadUnbrushedData();
	virtual Iterator* LoadBrushedData();
	virtual Iterator* LoadBrushedDataAverages();

    virtual FlatDataEntry* GetDataEntry(int entryID);
*/
    virtual Iterator* LoadData(DimensionSpace* dimSpace, bool dimCluster, bool showBand, bool brushed);
    virtual void MarkBrushedClusters(SBBrush* brush);
    virtual void MarkContourClusters(double radius, int flag);
    virtual double GetRootSqrtRadius();

    virtual void GetLeafSBBContour(int &num, SBBContourNode* &nodes) {};
    virtual void GetSBBContour(bool brushed, int &num, SBBContourNode* &nodes) {};

    SBBrush* GetSBBrush() {return sbBrush;}
    int GetMaxLevel() {return maxLevel;}

};



#endif

