#ifndef INMEMORYFLATDATASET_H
#define INMEMORYFLATDATASET_H

#include <fstream>

#include "DataStructure/FlatDataSet.h"
#include "DataStructure/DataBuffer.h"
#include "DataStructure/DimensionSpace.h"
#include "InMemoryFlatRowIterator.h"

class InMemoryFlatDataSet : public FlatDataSet
{
public: 
    DimensionSpace *allDimSpace;
    DataBuffer* dataBuffer;
    int* marks;
    double* coverage;
    bool hasDescription;
    std::string *descriptionArray;

public: 
	InMemoryFlatDataSet();
	~InMemoryFlatDataSet();

//    InMemoryFlatDataIterator<FlatDataEntry*>* LoadUnbrushedData(bool extents);
//    InMemoryFlatDataIterator<FlatDataEntry*>* LoadBrushedData(int brushOperID, bool extents);
//    InMemoryFlatDataIterator<FlatDataEntry*>* LoadData();
//    void ResetMarksAndCoverage();

//    bool ReadData(std::ifstream* infile, int dimNum, int itemNum);
    bool ReadData(std::ifstream* infile, DimensionSpace* dimSpace, int itemNum, bool hasDescription);
    Iterator* LoadRows(DimensionSpace* dimSpace, Query* query, bool dimCluster, bool ordering, int outputMode, bool loadDescriptions, bool storeDescriptions);
	Iterator* LoadColumns(DimensionSpace* dimSpace, Query *query);
    std::string GetItemDescription(int itemID);
};



#endif

