#ifndef NorminalDimension_H
#define NorminalDimension_H

#include <wx/hashmap.h>
#include <string>
#include "../Basic/CLinkList.h"
#include "Dimension.h"

struct PAV  //pointer and value that corresponding to a nominal value
{
    void* pointer;
    double value;

    PAV() 
	: pointer(NULL), value(0) {}

    PAV(void* p, double v) 
	: pointer(p), value(v) {}

};

WX_DECLARE_STRING_HASH_MAP(PAV, NorminalHash);

class NorminalDimension : public Dimension 
{
// Variables declaration
protected: 
    double interval;
    double currentValue;
    NorminalHash hash;


// End of variables declaration

public:
    /** Creates new NorminalDimension */
    NorminalDimension(); 

    //deconstructor
    ~NorminalDimension();
    
    void AddString(std::string str, double value);

    double GetNorValue(std::string valueString);
    double GetValue(std::string valueString);
    double GetNorValue(double value);

    void* GetPointer(std::string str);
    double GetNorValue(Data data);
    void GetNorValue(Data* data, double &norValue);
    void GetLabels(std::string* &labels, double* &values, int &labelNum);

    void SetMinMaxString(std::string string1, std::string string2);

    void GetNorValueWithMinMax(Data* data, double &norValue, double &norMin, double &norMax);
    void GetNorValueWithMinMax(double value, double &norValue, double &norMin, double &norMax);
    void ReadMetaInformation(std::ifstream *infile);
    void WriteMetaInformation(std::ofstream *outfile);

    void GetGroups(std::string* &groupValues, int* &groupSizes, int &groupNum);
    void SetGroups(std::string* groupValues, int* groupSizes, int groupNum);

    void ChangeMinMax(std::string valueString);

};

#endif