#ifndef _TimeHistogram_ITERATOR_H
#define _TimeHistogram_ITERATOR_H

#include "Basic/Iterator.h"
#include "Basic/Macros.h"
#include "DocTimeHistogram.h"
#include "DimensionSpace.h"
#include "Query.h"
#include "../Analysis/Sort/sorting.h"

class TimeHistogramIterator : public Iterator
{
protected:
    DimensionSpace* dimSpace;
    double *intervalValues;
    int intervalNum;
    Iterator *rowIter;

    int count;
    int dimNum;

    double **histograms;

    DocTimeHistogram* docTimeHistogram;

    ISHash **itemHashs;
    IIHash **importanceHashs;

public:
    TimeHistogramIterator(Query *query, IIHash *selectedItemHash, Iterator* rowIter, DimensionSpace* dimSpace, Dimension* timeDim);
    ~TimeHistogramIterator();

    void* GetNext();
	bool IsDone();

protected:
    int FindIndex(double norValue); 
    void AddRepresentativeItems(ISHash *hash, IIHash *ihash, int index, int importance, std::string destr);

};

#endif
