#include <string>
#include <fstream>
#include <sstream>
#include <ctime>

#include <wx/file.h>
#include <wx/datetime.h>
#include "KeywordProcess.h"
#include "../../Analysis/Sort/sorting.h"


KeywordProcess::KeywordProcess()
{
}

KeywordProcess::~KeywordProcess()
{
}

bool KeywordProcess::AddFreqFile(std::string fileName)
{
    //judge if the file can be read
    FILE *fptr = fopen(fileName.c_str(),"rb");
    if (!fptr) 
        return false;
    else
        fclose(fptr);

    std::ifstream infile (fileName.c_str());
    
    char buf[25000];
    int type, freq;
    std::string str;
    infile.getline(buf, 25000);

    SIHash::iterator it;
    while (infile.good())
    {
        infile >> type;
        infile >> freq;
        while (infile.peek() == ' ' || infile.peek() == '\t')
            infile.get();
        infile.getline(buf, 25000);
        str = buf;

        if (type != 0 && type != 6 && type != 11)
        {
            wxString wStr(str.c_str(), str.length());
            it = freqHash.find(wStr);
            if (it == freqHash.end())
            {   
                freqHash[wStr] = freq;
                typeHash[wStr] = type;
            }
            else
            {
                it->second += freq;
            }
        }
    }
    infile.close();
    return true;
}

void KeywordProcess::Output()
{
    int num = freqHash.size();
    std::string *keywords;
    SortStruct *sortArray;
    keywords = new std::string[num];
    sortArray = new SortStruct[num];

    int count = 0;
    SIHash::iterator it;
    it = freqHash.begin();
    while (it != freqHash.end())
    {
        keywords[count] = it->first.c_str();
        sortArray[count].value = it->second;
        sortArray[count].number = count;
        count++;
        it ++;
    }

    qsort( sortArray, num, sizeof( SortStruct ), DecreaseSort );

    std::ofstream outfile ("c:\\yangjing\\Fan\\video\\totalFreq.log");
    int picknum = 130;
    if (picknum > num)
        picknum = num;

    outfile << picknum << std::endl;

    int id;
    for (int i = 0; i < picknum; i++)
    {
        id = sortArray[i].number;
        outfile << typeHash[keywords[id].c_str()] << " " << sortArray[i].value << " " << keywords[id] << std::endl;
    }
    
    outfile.close();
    delete [] keywords;
    delete [] sortArray;
   
    
    
/*    SIHash::iterator it;
    std::ofstream outfile ("c:\\yangjing\\temp\\hellooo");

    it = freqHash.begin();
    while (it != freqHash.end())
    {
        outfile << it->first.c_str() << "  " << it->second << std::endl;
        it ++;
    }
    outfile.close();*/
}

bool KeywordProcess::MakeOKCFile(wxString path, wxArrayString *filenames)
{
    int i, j;

    std::string freqFilename = "c:\\yangjing\\Fan\\video\\totalFreq.log";
    
    FILE *fptr = fopen(freqFilename.c_str(),"rb");
    if (!fptr) 
        return false;
    else
        fclose(fptr);

    //read in keywords
    std::ifstream infile (freqFilename.c_str());
    int keywordNum;

    infile >> keywordNum;
    
    std::string *keywords;
    keywords = new std::string[keywordNum];

    char buf[25000];
    int freq, type;
    for (i = 0; i < keywordNum; i++)
    {
        infile >> freq >> type;
        while (infile.peek() == ' ' || infile.peek() == '\t')
            infile.get();
        infile.getline(buf, 25000);
        keywords[i] = buf;
    }
    infile.close();

    //read cc files and make okc file
    std::string pathname = path.c_str();
    std::string foldername = pathname.substr(pathname.find_last_of('\\')+1);
        
    std::string okcFilename = "c:\\yangjing\\Fan\\video\\";
    okcFilename += foldername + ".okc";

    std::ofstream outfile(okcFilename.c_str());
    
    int fileNum = filenames->Count();
    int dimNum = keywordNum + 2;

    //write meta data of the okc file
    outfile << dimNum << " " << fileNum << " E:\\video\\multichannel\\CNN" << std::endl;
    
    outfile << "T: Date" << std::endl;
    outfile << "Importance" << std::endl;
    std::string strtemp;
    for (i = 0; i < keywordNum; i++)
    {
        strtemp = keywords[i];
        while (strtemp.find(' ') != std::string::npos)
        {
            strtemp.replace(strtemp.find(' '), 1, "_");
        }
        outfile << "B: " << strtemp << std::endl;
    }
    outfile << "* " << std::endl;
    outfile << "0 1 100" << std::endl;
    for (i = 0; i < keywordNum; i++)
    {
        outfile << 0 << " " << 1 << " " << 2 << std::endl;
    }
        
    std::string filename;
    int *exists;
    exists = new int [keywordNum];

    wxString temp;
    for (i = 0; i < keywordNum; i++)
    {
        temp = keywords[i].c_str();
        keywords[i] = temp.MakeLower().c_str();
    }

//std::ofstream onfile ("countfiles");
//double w = 0;
    double importance;
    for (j = 0; j < fileNum; j++)
    {
        filename = (*filenames)[j];
        importance = GetImportance(pathname+"\\"+filename);
/*if (importance > 0.55 )
{
    std::string name = pathname+"\\"+filename;
    name = name.substr(0, name.length()-2) + "mpg";
    wxFile file(name.c_str());
    if (file.Length() < 110000000)
    {

        onfile << filename << " " << importance << " " << (int)file.Length() << std::endl;
        w += file.Length();
    }
}*/
        GetKeywordExists( pathname+"\\"+filename, keywordNum, keywords, exists );
        
        outfile << GetVideoName(filename).c_str() << " " << GetTimeString(filename).c_str() 
            << " " << importance << " ";
        
        for (i = 0; i < keywordNum; i++)
        {
            outfile << exists[i] << " ";
        }
        outfile << std::endl;
    }
    outfile.close();
//onfile << w << std::endl;
//onfile.close();
    delete [] keywords;
    delete [] exists;
    return true;
}

double KeywordProcess::GetImportance(std::string fileName)
{
    std::string sbFileName = fileName.substr(0, fileName.length()-2);
    sbFileName += "sbi.txt";

    double importance = 0, temp;
    std::ifstream infile (sbFileName.c_str());
    char buf[1000];
    infile.getline(buf, 1000);

    infile.getline(buf, 1000);
    while (infile.good())
    {
        char *token = strtok(buf, " \t");  // get the first token name

		for (int i = 0; i < 7; i++)
		{
            token = strtok( NULL, " \t");
        }

        temp = atof(token); 

        if (temp > importance)
            importance = temp;

        infile.getline(buf, 1000);
    }
    infile.close();

    return importance;
}

void KeywordProcess::GetKeywordExists(std::string filename, int keywordNum, std::string *keywords, int *exists)
{
    std::ifstream infile (filename.c_str());

    int i;
    for (i = 0; i < keywordNum; i++)
    {
        exists[i] = 0;
    }

    char buf[25000];
    std::string line;
    wxString temp;
    infile.getline(buf, 25000);
    while (infile.good())
    {
        temp = buf;
        line = temp.MakeLower().c_str();
        for (int i = 0; i < keywordNum; i++)
        {
            if (exists[i] == 0)
            {
                int pos = line.find(keywords[i]);
                if (pos >= 0)
                {
                    if (pos == 0 || !isalpha(line[pos-1]))
                    {
                        int pos2 = pos + keywords[i].length();
                        if (pos2 == line.length() || !isalpha(line[pos2]))
                            exists[i] = 1;
                    }
                }
            }
        }
        infile.getline(buf, 25000);
    }
   
    infile.close();
}

std::string KeywordProcess::GetTimeString(std::string filename)
{
    int year = atoi(filename.substr(0, 4).c_str());     
    int month = atoi(filename.substr(5, 7).c_str());
    wxDateTime::Month mon;
    switch (month)
    { 
    case 1: mon = wxDateTime::Jan;
        break;
    case 2: mon = wxDateTime::Feb;
        break;
    case 3: mon = wxDateTime::Mar;
        break;
    case 4: mon = wxDateTime::Apr;
        break;
    case 5: mon = wxDateTime::May;
        break;
    case 6: mon = wxDateTime::Jun;
        break;
    case 7: mon = wxDateTime::Jul;
        break;
    case 8: mon = wxDateTime::Aug;
        break;
    case 9: mon = wxDateTime::Sep;
        break;
    case 10: mon = wxDateTime::Oct;
        break;
    case 11: mon = wxDateTime::Nov;
        break;
    case 12: mon = wxDateTime::Dec;
        break;
    }
    int day = atoi(filename.substr(8, 10).c_str());        
    int h = atoi(filename.substr(13, 15).c_str());        
    int m = atoi(filename.substr(16, 18).c_str());        
    wxDateTime dt(day, mon, year, h, m);
    std::string str =  dt.FormatDate().c_str();
//    std::string str =  dt.Format().c_str();
//    str = "(" + str + ")";
    return str;
}

std::string KeywordProcess::GetVideoName(std::string filename)
{
    std::string videoName = filename.substr(0, filename.find('.'));
    videoName += ".mpg";
    return videoName;
}


bool KeywordProcess::LoadImportantShots(wxString path, wxArrayString *filenames, DBManager* db)
{
    std::string pathname = path.c_str();
    std::string foldername = pathname.substr(pathname.find_last_of('\\')+1);

    tableName = "wx" + foldername + "Shots";

  //  db->ExecuteUpdate(GetDropTableString(tableName));

    db->ExecuteUpdate("drop table wxcnnshots");

    db->ExecuteUpdate(GetCreateTableString(tableName));

    int j;
    int timecount = 0;
    std::string filename;
    int fileNum = filenames->Count();
    for (j = 0; j < fileNum; j++)
    {
        filename = (*filenames)[j];
        LoadShotFile(db, pathname+"\\"+filename, filename, j, timecount);
    }

    delete db;
    return true;
}

void KeywordProcess::LoadShotFile(DBManager* db, std::string fileName, std::string videoname, int id, int &time)
{
    std::string sbFileName = fileName.substr(0, fileName.length()-2);
    sbFileName += "sbi.txt";

    std::string videoFileName = videoname.substr(0, videoname.length()-2);
    videoFileName += "mpg";

    int starttime, endtime, temp;
    double importance;
    std::ifstream infile (sbFileName.c_str());
    char buf[1000];
    infile.getline(buf, 1000);

    infile.getline(buf, 1000);
    while (infile.good())
    {
        char *token = strtok(buf, " \t");  // get the first token name

		for (int i = 0; i < 4; i++)
		{
            token = strtok( NULL, " \t");
        }

        starttime = atoi(token);
        token = strtok( NULL, " \t");
        endtime = atoi(token);
        token = strtok( NULL, " \t");

        temp = atoi(token); 
        token = strtok( NULL, " \t");

        importance = atof(token);

        db->ExecuteUpdate(GetInsertTableString(tableName, videoFileName, id, time, starttime, endtime, importance));
        time ++;

        infile.getline(buf, 1000);
    }
    db->Commit();

    infile.close();
}


std::string KeywordProcess::GetCreateTableString(std::string dataTableName)
{
    std::ostringstream oss;

	oss << "create table " << dataTableName << 
        "(name char(50), time number(20), id number(20), startTime number(20), endTime number(20), importance number(15,13))";
	return oss.str();

}


std::string KeywordProcess::GetInsertTableString(std::string dataTableName, std::string name, int time, int id, int starttime, int endtime, double importance)
{
    std::ostringstream oss;

    name = "'" + name + "'";

	oss << "insert into " << dataTableName << " (name,time,id,startTime,endTime,importance) values (";
    oss << name.c_str() << "," << time << "," << id << "," 
        << starttime << "," << endtime << "," << importance << ")"; 
	return oss.str();     
}


std::string KeywordProcess::GetDropTableString(std::string dataTableName)
{
    std::ostringstream oss;

	oss << "drop table " << dataTableName;
	return oss.str();
}


/*
double hex2f(std::string s)
{
    double f = 0.0;
    for (int i=0; i<s.length; i++) {
        if ('0' <= s[i] && s[i] <= '9')
            f = f * 16.0 + (s[i] - '0');
        else if ('A' <= s[i] && s[i] <= 'Z')
            f = f * 16.0 + (s[i] - 'A' + 10.0);
        else if ('a' <= s[i] && s[i] <= 'z')
            f = f * 16.0 + (s[i] - 'a' + 10.0);
    }
    return f;
}
*/
