#ifndef _KEYWORD_PROCESS_H
#define _KEYWORD_PROCESS_H

#include <string>
#include <fstream>

#include <wx/hashmap.h>
#include "../../DBConnection/DBManager.h"

WX_DECLARE_STRING_HASH_MAP(int, SIHash);

class KeywordProcess
{
protected:
    SIHash typeHash;
    SIHash freqHash;

    std::string tableName;

public:
    KeywordProcess();
    ~KeywordProcess();
    bool AddFreqFile(std::string fileName);
    bool MakeOKCFile(wxString path, wxArrayString *filenames);
    void GetKeywordExists(std::string filename, int keywordNum, std::string *keywords, int *exists);
    std::string GetTimeString(std::string filename);
    std::string GetVideoName(std::string filename);

    double GetImportance(std::string filename);
    
    bool LoadImportantShots(wxString path, wxArrayString *filenames, DBManager* db);
    void LoadShotFile(DBManager* db, std::string fileName, std::string videoname, int id, int &time);
    std::string GetCreateTableString(std::string dataTableName);
    std::string GetInsertTableString(std::string dataTableName, std::string name, int time, int id, int starttime, int endtime, double importance);
    std::string GetDropTableString(std::string dataTableName);
    
    void Output();
};


#endif

