#include <sstream>
#include "VideoShotIterator.h"


VideoShotIterator::VideoShotIterator(DBManager* dbManager, IIHash *selectedItemHash)
{
    this->selectedItemHash = selectedItemHash;
    dbManager = dbManager;

    std::ostringstream oss;
    oss << "select ";
    oss << "name,id,startTime,endTime from wxCNNShots t where t.importance > 0 order by time"; 

    re = dbManager->ExecuteQuery(oss.str());

    shot = new DocVideoShot();

    isDone = true;
    while (!re->isDone())
    {
        re->next();
        id = re->getInt(1);
        if (selectedItemHash->find(id) != selectedItemHash->end())
        {
            name = re->getString(0);
            startTime = re->getInt(2);
            endTime = re->getInt(3);
            isDone = false;
            break;
        }
    }
}	


VideoShotIterator::~VideoShotIterator()
{
    delete re;
    delete shot;
}


void* VideoShotIterator::GetNext()
{
    if (isDone == true)
        return NULL;

    shot->SetVideoName(name);
    shot->SetVideoID(id);
    shot->SetStartTime(startTime);
    shot->SetEndTime(endTime);
    
    isDone = true;
    while (!re->isDone())
    {
        re->next();
        id = re->getInt(1);
        if (selectedItemHash->find(id) != selectedItemHash->end())
        {
            name = re->getString(0);
            startTime = re->getInt(2);
            endTime = re->getInt(3);
            isDone = false;
            break;
        }
    }
    return shot;
}
    

bool VideoShotIterator::IsDone()
{
    return isDone;
}
