#include "DemoDrawer.h"
#include "../Basic/LinkListIterator.h"

DemoDrawer::DemoDrawer()
{
    lineList = new CLinkList();
/*    circleList = new CLinkList();
    lineList = new CLinkList();
    circleList = new CLinkList();
    arcList = new CLinkList();
    partialDiskList = new CLinkList();
    linesList = new CLinkList();
    rectangleList = new CLinkList();
    rectangle2List = new CLinkList();
    filledRectangleList = new CLinkList();
    pointList = new CLinkList();
    pointsList = new CLinkList();
    polygonList = new CLinkList();
    filledPolygonList = new CLinkList();
    filledBandList = new CLinkList();
    transparentBandList = new CLinkList();
    transparentBand2List = new CLinkList();
    transparentSquareList = new CLinkList();
    transparentSquare2List = new CLinkList();
    textList = new CLinkList();*/
}

DemoDrawer::~DemoDrawer()
{
    LinkListIterator *iter;

    iter = new LinkListIterator(lineList);
    while (! iter->IsDone())
    {
        Line *line = (Line *) iter->GetNext();
        delete line;
    }
    delete iter;
    delete lineList;

/*    iter = new LinkListIterator(circleList);
    while (! iter->IsDone())
    {
        Circle *circle = (Circle *) iter->GetNext();
        delete circle;
    }
    delete iter;
    delete circleList;*/
}

//drawer draws a canvas
void DemoDrawer::RefreshCanvas(grCanvas* canvas)
{
    double x1 = ((double) rand()) / RAND_MAX;
    double y1 = ((double) rand()) / RAND_MAX;
    double x2 = ((double) rand()) / RAND_MAX;
    double y2 = ((double) rand()) / RAND_MAX;
    AddLine(x1, y1, x2, y2);
 
	//get the canvas ready
	PrepareCanvas(canvas);

    canvas->SetForeground(RGBt(0.3f, 0.6f, 0.9f));

    //get data and draw them
    LinkListIterator *iter;

    iter = new LinkListIterator(lineList);
    while (! iter->IsDone())
    {
        Line *line = (Line *) iter->GetNext();
        canvas->DrawLine(line->x1, line->y1, line->x2, line->y2);
    }
    delete iter;

/*    iter = new LinkListIterator(circleList);
    while (! iter->IsDone())
    {
        Circle *circle = (Circle *) iter->GetNext();
        canvas->DrawCircle(circle->centerx, circle->centery, circle->radius, circle->offset);
    }
    delete iter;

    iter = new LinkListIterator(arcList);
    while (! iter->IsDone())
    {
        ArcType *arc = (ArcType *) iter->GetNext();
        canvas->DrawArc(arc->centerx, arc->centery, arc->radius, arc->start_angle, arc->sweep_angle);
    }
    delete iter;

    iter = new LinkListIterator(partialDiskList);
    while (! iter->IsDone())
    {
        PartialDisk *pd = (PartialDisk *) iter->GetNext();
        canvas->DrawPartialDisk(pd->centerx, pd->centery, pd->inner_radius, 
					            pd->outer_radius, pd->start_angle, pd->sweep_angle);
    }
    delete iter;

    iter = new LinkListIterator(textList);
    while (! iter->IsDone())
    {
        TextType *text = (TextType *) iter->GetNext();
        canvas->DrawString(text->str, text->baseX, text->baseY, text->angle, text->scale);
    }
    delete iter;
*/
    //you can complete the drawing here...
}

void DemoDrawer::ButtonDown(grCanvas* canvas, int button, Vec2 p)
{
//    AddCircle(0.6, 0.6, 0.1, 0.02);
    canvas->Refresh();
}

void DemoDrawer::PrepareCanvas(grCanvas* canvas)
{
    canvas->SetCurrent();
    canvas->SetTopLeftOrigin();
    canvas->SetViewport();

    canvas->SetBackground(colorManager->GetColor(BG));
    canvas->Clear();
}

void DemoDrawer::AddLine(double x1, double y1, double x2, double y2)
{
    Line *line = new Line;
    line->x1 = x1;
    line->y1 = y1;
    line->x2 = x2;
    line->y2 = y2;
    lineList->AddNodeAtEnd(line);
}

void DemoDrawer::AddCircle(double centerx, double centery, double radius, double offset)
{
    Circle *circle = new Circle;
    circle->centerx = centerx;
    circle->centery = centery;
    circle->radius = radius;
    circle->offset = offset;
    circleList->AddNodeAtEnd(circle);
}

void DemoDrawer::AddArc(double centerx, double centery, double radius, double start_angle, double sweep_angle)
{
    ArcType *arc = new ArcType;
    arc->centerx = centerx;
    arc->centery = centery;
    arc->radius = radius;
    arc->start_angle = start_angle;
    arc->sweep_angle = sweep_angle;
    arcList->AddNodeAtEnd(arc);
}

void DemoDrawer::AddPartialDisk(double centerx, double centery, double inner_radius, 
                                double outer_radius, double start_angle, double sweep_angle)
{
    PartialDisk *partialDisk = new PartialDisk;
    partialDisk->centerx = centerx;
    partialDisk->centery = centery;
    partialDisk->inner_radius = inner_radius;
    partialDisk->outer_radius = outer_radius;
    partialDisk->start_angle = start_angle;
    partialDisk->sweep_angle = sweep_angle;
    partialDiskList->AddNodeAtEnd(partialDisk);
}

void DemoDrawer::AddLines(const ARR<Vec2> &pts)
{
    Lines *lines = new Lines;
    lines->pts = pts;
    linesList->AddNodeAtEnd(lines);
}

void DemoDrawer::AddRectangle(double x, double y, double width, double ht)
{
    RectangleType *rect = new RectangleType;
    rect->x = x;
    rect->y = y;
    rect->width = width;
    rect->ht = ht;
    rectangleList->AddNodeAtEnd(rect);
}

void DemoDrawer::AddRectangle2(double x1, double x2, double y1, double y2)
{
    Rectangle2 *rect = new Rectangle2;
    rect->x1 = x1;
    rect->x2 = x2;
    rect->y1 = y1;
    rect->y2 = y2;
    rectangle2List->AddNodeAtEnd(rect);
}

void DemoDrawer::AddFilledRectangle(double x, double y, double width, double ht)
{
    RectangleType *filledRectangle = new RectangleType;
    filledRectangle->x = x;
    filledRectangle->y = y;
    filledRectangle->width = width;
    filledRectangle->ht = ht;
    filledRectangleList->AddNodeAtEnd(filledRectangle);
}

void DemoDrawer::AddPoint(double x, double y, double size)
{
    Point *point = new Point;
    point->x = x;
    point->y = y;
    point->size = size;
    pointList->AddNodeAtEnd(point);
}

void DemoDrawer::AddPoints(const ARR<Vec2> &pts, double size)
{
    Points *points = new Points;
    points->pts = pts;
    points->size = size;
    pointsList->AddNodeAtEnd(points);
}

void DemoDrawer::AddPolygon(const ARR<Vec2> &pts)
{
    PolygonType *polygon = new PolygonType;
    polygon->pts = pts;
    polygonList->AddNodeAtEnd(polygon);
}

void DemoDrawer::AddFilledPolygon(const ARR<Vec2> &pts)
{
    PolygonType *polygon = new PolygonType;
    polygon->pts = pts;
    filledPolygonList->AddNodeAtEnd(polygon);
}

void DemoDrawer::AddFilledBand(const ARR<Vec2> &pts, double ratio)
{
    FilledBand *filledBand = new FilledBand;
    filledBand->pts = pts;
    filledBand->ratio = ratio;
    filledBandList->AddNodeAtEnd(filledBand);
}

void DemoDrawer::AddTransparentBand(const ARR<Vec2> &pts,
                                    double opacity_bottom, double opacity_top,
                                    RGBt color_bottom, RGBt color_top)
{
    TransparentSquare *bs = new TransparentSquare;
    bs->pts = pts;
    bs->opacity_bottom = opacity_bottom;
    bs->opacity_top = opacity_top;
    bs->color_bottom = color_bottom;
    bs->color_top = color_top;
    transparentBandList->AddNodeAtEnd(bs);
}

void DemoDrawer::AddText(std::string str, float baseX, float baseY, float angle, float scale)
{
    TextType *text = new TextType;
    text->str = str;
    text->baseX = baseX;
    text->baseY = baseY;
    text->angle = angle;
    text->scale = scale;
    textList->AddNodeAtEnd(text);
}

