#ifndef DimstackDrawer_H
#define DimstackDrawer_H

#include "../TableDrawer.h"
#include "DimstackDrawerSettings.h"
#include "DimstackVisualAxes.h"
#include "DimstackVisualBin.h"

class grCanvas;
class GryphVisualAxes;

enum
{ 
    Dimstack_NONE = 1,
    Dimstack_MOVE = 2,
};



class DimstackDrawer : public TableDrawer
{
protected:
    DimstackDrawerSettings* settings;
    int inputMode;
    int currentBin;

public:
	DimstackDrawer();
	~DimstackDrawer();
	
	void PrepareCanvas();
    void PrepareDrawLayer(Layer* layer);
    void AfterDrawLayer(Layer* layer);
    void DrawBin(VisualBin *Bin);
    void DrawAxes(VisualAxes *Bin);

    DimstackDrawerSettings* GetSettings() {return settings;}

    VisualElementMeta* CreateVisualBinMeta(DocumentManager* docManager, bool brushed);
    VisualElementMeta* CreateVisualAxesMeta();

    int FindBinID(float x, float y);
    void ButtonUp(grCanvas* canvas, int button, Vec2 p);
    void MouseMotion(grCanvas* canvas, Vec2 p);
    void ButtonDown(grCanvas* canvas, int button, Vec2 p);
    void DoubleClick(grCanvas* canvas, int button, Vec2 p);
    void SelectedBinsChanged();

    void CurrentDimensionSpaceChanged();
    void AllDimensionSpaceDeleted();





};

#endif

