#include <stdio.h>
#include "DimstackVisualAxes.h"

DimstackVisualAxes::DimstackVisualAxes() : VisualAxes()
{

}

DimstackVisualAxes::~DimstackVisualAxes()
{
}

void DimstackVisualAxes::SetDimensionSpace(DimensionSpace* dimSpace)
{
    this->dimSpace = dimSpace;
    dimNum = dimSpace->GetSize();
    if (dimNum == 0)
        return;

    cardinalities = new int [dimNum];

    int i;
    binNum = 1;
    for (i = 0; i < dimNum; i++)
    {
        cardinalities[i] = dimSpace->GetDimension(i)->GetCardinality();
        binNum *= cardinalities[i];
    }
}

void DimstackVisualAxes::SetSettings(DimstackDrawerSettings* settings)
{
    this->settings = settings;
}

void DimstackVisualAxes::GetBinXYPosSize(int id, int* indexes, float &xPos, float&yPos, float &xSize, float &ySize)
{
/*    if (binArrangeMode != TRADITIONALDIMSTACK)
    {
        settings->GetTextureXYPosition(itemID, xPos, yPos);
        settings->GetTextureXYSize(itemID, xSize, ySize);
    }
    else
    {*/
        float sizex, sizey, startx, starty;
        int i = 0; 
        sizex = 1.0f;
        startx = 0;
        while (i < dimNum)
        {
            sizex /= cardinalities[i];
            startx += indexes[i] * sizex;
            i += 2;
        }
        i = 1; 
        sizey = 1.0f;
        starty = 0;
        while (i < dimNum)
        {
            sizey /= cardinalities[i];
            starty += indexes[i] * sizey;
            i += 2;
        }
        xSize = sizex / 2.0f - 0.0001;
        ySize = sizey / 2.0f - 0.0001;
        xPos = startx + xSize;
        yPos = starty + ySize;
//    }
}

float DimstackVisualAxes::GetBinZPos(int itemID)
{
    return settings->GetTextureZPosition(itemID);
}

/*
void DimstackVisualAxes::GetBinXYSize(int itemID, float &xSize, float &ySize)
{
    settings->GetTextureXYSize(itemID, xSize, ySize);
}*/

int DimstackVisualAxes::GetDimensionAxesWidth(int id)
{
    return 1;
}

int DimstackVisualAxes::GetAxes(int id, float* &pos, bool &vertical)
{
    int i; 
    int num, intervalNum;
    if (id == 0 || id == 1)
    {
        num = cardinalities[id] + 1;
        intervalNum = cardinalities[id];
    }
    else
    {
        i = id % 2;
        num = 1;
        while (i <= id - 2)
        {
            num *= cardinalities[i]; 
            i += 2;
        }
        intervalNum = num * cardinalities[i];
        num *= cardinalities[i] - 1;
    }

    pos = new float [num];

    if (id % 2 == 0)
    {
        vertical = true;
    }
    else
    {
        vertical = false;
    }

    float interval = 1.0 / intervalNum;
    float currpos;
    if (id == 0 || id == 1)
    {
        currpos = 0; 
        for (i = 0; i < num; i++)
        {
            pos[i] = currpos;
            currpos += interval;
        }
    }
    else
    {
        int count = 0;
        int index = 0;
        currpos = 0;
        for (i = 0; i < intervalNum; i++)
        {
            if (index != 0)
            {
                pos[count] = currpos;
                count ++;
            }

            currpos += interval;

            index ++;
            if (index == cardinalities[id])
                index = 0;
        }
    }

    return num;
}