#ifndef _GRAPH_VISUAL_AXES_H
#define _GRAPH_VISUAL_AXES_H

#include "../VisualAxes.h"
#include "DimstackDrawerSettings.h"

class VisualAxes;
class DimstackDrawerSettings;

class DimstackVisualAxes : public VisualAxes
{
protected:
    DimstackDrawerSettings* settings;
    DimensionSpace* dimSpace;
    int dimNum;
    int* cardinalities;
    int binNum;

public:
	DimstackVisualAxes();
	~DimstackVisualAxes();

    void SetDimensionSpace(DimensionSpace* dimSpace);
    void SetSettings(DimstackDrawerSettings* settings);

//    void GetBinXYPos(int itemID, float &xPos, float&yPos);

    float GetBinZPos(int itemID); 

//    void GetBinXYSize(int itemID, float &xSize, float &ySize);

    void GetBinXYPosSize(int id, int* indexes, float &xPos, float&yPos, float &xSize, float &ySize);
    int GetBinNumber() {return binNum;}
    int GetAxes(int id, float* &pos, bool &vertical);

    int DimstackVisualAxes::GetDimensionAxesWidth(int id);
    int GetDimensionNumber() {return dimNum;}
};

#endif

