#ifndef GlyphDrawer_H
#define GlyphDrawer_H

#include "../TableDrawer.h"
#include "GlyphDrawerSettings.h"
#include "GlyphVisualAxes.h"
#include "GlyphVisualRow.h"

class grCanvas;
class GryphVisualAxes;

enum
{ 
    GLYPH_NONE = 1,
    GLYPH_MOVE = 2,
};



class GlyphDrawer : public TableDrawer
{
protected:
    GlyphDrawerSettings* settings;
    int inputMode;
    int currentItem;

public:
	GlyphDrawer();
	~GlyphDrawer();
	
	void PrepareCanvas();
    void PrepareDrawLayer(Layer* layer);
    void AfterDrawLayer(Layer* layer);
	void DrawData(VisualRow *row);

    GlyphDrawerSettings* GetSettings() {return settings;}

    VisualElementMeta* CreateVisualRowMeta(DocumentManager* docManager, bool brushed, bool hier);
    VisualElementMeta* CreateVisualAxesMeta();

    int FindItemID(float x, float y);
    void ButtonUp(grCanvas* canvas, int button, Vec2 p);
    void MouseMotion(grCanvas* canvas, Vec2 p);
    void ButtonDown(grCanvas* canvas, int button, Vec2 p);
    void DoubleClick(grCanvas* canvas, int button, Vec2 p);
    void SelectedItemsChanged();

    void DrawPlainData(GlyphVisualRow *row);
    void DrawTexturedData(GlyphVisualRow *row);




};

#endif

