#include <stdio.h>
#include "GlyphVisualRow.h"

GlyphVisualRow::GlyphVisualRow() : VisualRow()
{
}

GlyphVisualRow::~GlyphVisualRow()
{
}

void GlyphVisualRow::SetTexture(GLuint texture)
{
	this->texture = texture;
}

void GlyphVisualRow::SetMaskTexture(GLuint texture)
{
	this->maskTexture = texture;
}
//width: the width of the original texture object
void GlyphVisualRow::SetWidth(int width)        
{	
	this->width = width;
}

//height: the height of the origianl texture object
void GlyphVisualRow::SetHeight(int height)      
{
	this->height = height;
}

void GlyphVisualRow::SetXPosition(float x)
{
	xPos = x;
}

void GlyphVisualRow::SetYPosition(float y)
{
	yPos = y;
}

void GlyphVisualRow::SetZPosition(float z)
{
	zPos = z;
}

void GlyphVisualRow::SetXSize(float x)
{
	xSize = x;
}

void GlyphVisualRow::SetYSize(float y)
{
	ySize = y;
}

GLuint GlyphVisualRow::GetTexture()
{
	return texture;
}

//width: the width of the original texture object
int GlyphVisualRow::GetWidth()        
{	
	return width;
}

//height: the height of the origianl texture object
int GlyphVisualRow::GetHeight()      
{
	return height;
}

float GlyphVisualRow::GetXPosition()
{
    float size = GetXSize();
    if ( (xPos - size) < 0 )
        return size;
    else if ( (xPos + size) > 1 )
        return 1-size;
    else
    	return xPos;
}

float GlyphVisualRow::GetYPosition()
{
    float size = GetYSize();
    if ( (yPos - size) < 0 )
        return size;
    else if ( (yPos + size) > 1 )
        return 1-size;
    else
    	return yPos;
}

float GlyphVisualRow::GetZPosition()
{
	return zPos;
}

float GlyphVisualRow::GetXSize()
{
    if (width > height)
    	return xSize;
    else
        return xSize * ((float)width) / height;
}

float GlyphVisualRow::GetYSize()
{
    if (height > width)
        return ySize;
    else
        return ySize * ((float)height) / width;
}