#ifndef _Glyph_VISUAL_Row_META_H
#define _Glyph_VISUAL_Row_META_H

#include "../VisualRowMeta.h"
#include "GlyphDrawer.h"
#include "GlyphVisualAxes.h"
#include "../VisualElementsIterator.h"

class VisualElementsIterator;
class GlyphDrawer;

class GlyphVisualRowMeta : public VisualRowMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    GlyphDrawer* drawer;
    GlyphVisualAxes *axes;
    GlyphDrawerSettings* settings;

    grCanvas* canvas;
    int count;

    int* pos;
    int w, h;
    float* colorData;
    float* plainData;
    
    int glyphStyle;

    int focusItem;

    GLuint maskTexture;

    std::string globalPath;


public:
    GlyphVisualRowMeta();
	GlyphVisualRowMeta(GlyphDrawer* drawer, 
        DocumentManager* docManager, bool brushed, bool hier);
	~GlyphVisualRowMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);
    void Convert1(VisualElement* visualEle, DocElement* docEle);

protected:
    bool GetBitMap(int glyphID, std::string imageName, int &w, int &h, float* data, float*& colorData);
    void GetPlainBitMap(RGBt color, int w, int h, float* cdata);


};

#endif

