//  A layer can be an axes layer, a selected data items layer, a unselected 
//  data items layer, a label layer, or other layers. Users can show/hide axes,
//  data items, labels, or other visual elements by turning on/off the corresponding 
//  layers.  

#ifndef _LAYER_H
#define _LAYER_H

#include "Basic/Iterator.h"
#include "DocumentManager.h"
//#include "VisualElementMeta.h"
//#include "TableDrawer.h"
//#include "VisualElementsIterator.h"

class VisualElementMeta;
class VisualElementsIterator;
class TableDrawer;
class DocumentManager;

class Layer 
{
public:
    enum Display_Mode
    {
        DRAW,
        LOAD
    };

protected:
    VisualElementMeta* meta;
    int layerType;
    Display_Mode displayMode;

    Layer* dependantLayer;

    bool translucent;

public:
	Layer(int type);
	~Layer();

    int GetLayerType();
    Display_Mode GetDisplayMode();
//    VisualElementsIterator* IterateVisualElements(TableDrawer *drawer);
    VisualElementMeta* CreateVisualElementMeta(TableDrawer* drawer, DocumentManager* docManager);

    bool IsTranslucent() {return translucent;}
};

#endif

