#ifndef ParcoordDrawer_H
#define ParcoordDrawer_H

//#include "../Basic/grCanvas.h"
//#include "VisualElementMeta.h"
#include "ParcoordVisualRowMeta.h"
#include "ParcoordVisualRow.h"
#include "ParcoordVisualAxesMeta.h"
#include "ParcoordVisualAxes.h"
#include "ParcoordVisualLabelMeta.h"
#include "ParcoordVisualRulerMeta.h"


class grCanvas;

class ParcoordDrawer : public TableDrawer
{
protected:
    int axNum;

public:
	ParcoordDrawer();
	~ParcoordDrawer();
	
    int GetAxNum();
    bool SetAxNum(int axNum);
	void PrepareCanvas();
    void PrepareDrawLayer(Layer* layer);
    void AfterDrawLayer(Layer* layer);
    void DrawData(VisualRow *data);
    void DrawAxes(VisualAxes *visAxes);
    void DrawRuler(VisualRuler *visRuler);

    VisualElementMeta* CreateVisualRowMeta(DocumentManager* docManager, bool brushed, bool hier);
    VisualElementMeta* CreateVisualAxesMeta();
    VisualElementMeta* CreateVisualDimensionNameMeta(DocumentManager* docManager);
    VisualElementMeta* CreateVisualDimensionLabelMeta(DocumentManager* docManager);
    VisualElementMeta* CreateVisualRulerMeta(DocumentManager* docManager);

    bool IsNeedDimensionClusterMinMaxInfo();
    void DrawLabel(VisualLabel *label);

protected:
    void DrawMean(ParcoordVisualRow* data);
    void DrawBand(ParcoordVisualRow* data);

};

#endif

