#ifndef _PARCOORD_VISUAL_AXES_H
#define _PARCOORD_VISUAL_AXES_H

#include "../VisualAxes.h"

class VisualAxes;

class ParcoordVisualAxes : public VisualAxes
{
protected:
    int axNum;  //number of axes used to display a non-leaf dimension;
    float **positions;
    RGBt** colors;  
    float **widths;

    int segNum;
    int* segDimIDs;
    int* segTypes;
    float* segPositions;
    RGBt* segColors;
    float* segWidths;

    int* dimIDs;

public:
	ParcoordVisualAxes();
	~ParcoordVisualAxes();

    bool SetDimensionNum(int num);
    bool SetAxNum(int num);
    int GetAxNum();

    void SetAxInterval(int axID, float interval);
    void SetDimensionPosition(int dimID, float pos);;
    void ResetSegPositions();

    void SetDimensionColor(int dimID, RGBt color);
    void SetColor(int dimID, int axID, RGBt color);
    void ResetSegColors();

    void SetDimensionWidth(int dimID, float width);
    void ResetSegWidths();


    bool CreateSegments();

    float GetSegPosition(int segID);
    RGBt GetSegColor(int segID);
    float GetSegWidth(int segID);
    int GetSegNum();
    void GetSegInformation(int segID, int &dimID, int &type);

    float GetDimensionPosition(int order);
    float GetDimensionPositionByDimensionID(int dimID);
    void SetDimensionID(int order, int dimID);


    
protected: 
    void Init();
};

#endif

