#ifndef _PARCOORD_VISUAL_LABEL_META_H
#define _PARCOORD_VISUAL_LABEL_META_H

#include "../VisualElementMeta.h"
#include "ParcoordDrawer.h"
#include "ParcoordVisualAxes.h"
#include "../VisualElementsIterator.h"

class VisualElementsIterator;
class ParcoordDrawer;

class ParcoordVisualLabelMeta : public VisualElementMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    ParcoordDrawer* drawer;
    ParcoordVisualAxes *axes;
    
    float angle;
    float scale;
    float shiftX;
    float shiftY;
    float minShiftX;
    float minShiftY;

public:
    ParcoordVisualLabelMeta();
	ParcoordVisualLabelMeta(ParcoordDrawer* drawer, DocumentManager* docManager, 
        float angle, float scale, float shiftX, float shiftY,
        float minShiftX, float minShiftY);
	~ParcoordVisualLabelMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);
};

#endif

