#ifndef _PARCOORD_VISUAL_DATA_H
#define _PARCOORD_VISUAL_DATA_H

#include "../VisualRow.h"

class ParcoordVisualRow : public VisualRow
{
public:
    int segNum;
    int vNum;
    
    float** vPositions;
    float* segPositions;

    RGBt* colors;
    bool showBand;

public:
	ParcoordVisualRow();
	~ParcoordVisualRow();

    bool SetSegNum(int num);
    bool SetVNum(int num);

    void SetColor(int vID, RGBt color);
    void SetSegPosition(int segID, float pos);
    
    void SetVPosition(int vID, int segID, float pos);

    float GetSegPosition(int segID);
    float GetVPosition(int vID, int segID);
    
    RGBt GetVColor(int vID);
    int GetSegNum();
    int GetVNum();

    void SetShowBand(bool show) {showBand = show;}
    bool IsShowBand() {return showBand;}

    
protected:
    void Init();

};

#endif

