#ifndef _TABLE_DRAWER_H
#define _TABLE_DRAWER_H

#include "../Interface/grCanvas.h"
//#include "../Color/ColorManager.h"
//#include "../DocumentManager.h"
#include "Drawer.h"
#include "Layer.h"
#include "VisualRow.h"
#include "VisualBin.h"
#include "VisualColumn.h"
#include "VisualTimeHistogram.h"
#include "VisualAxes.h"
#include "VisualLabel.h"
#include "VisualRuler.h"
#include "VisualElementMeta.h"
#include "VisualElementsIterator.h"
//#include "ViewManager.h"
//#include "TableDrawerSettings.h"

//class Drawer;
//class Layer;
//class VisualElementMeta;
class VisualRow;
class VisualColumn;
class VisualTimeHistogram;
class VisualAxes;
class VisualLabel;
class VisualRuler;
//class DocumentManager;
class VisualBin;
//class TableDrawerSettings;

class grCanvas;
class ViewManager;

class TableDrawer : public Drawer
{
protected:

    bool omitColor;

    //to be removed
    bool showBand;
    bool showMean;

public:
	TableDrawer();
	virtual ~TableDrawer();
	
	virtual void RefreshCanvas(grCanvas* canvas);
	virtual void PrepareCanvas();
    virtual void PrepareDrawLayer(Layer* layer);
    virtual void AfterDrawLayer(Layer* layer);
    virtual void DrawData(VisualRow* data);
	virtual void DrawColumn(VisualColumn* column);
	virtual void DrawTimeHistogram(VisualTimeHistogram* timeHistogram);
	virtual void DrawBin(VisualBin* bin);

    virtual void DrawAxes(VisualAxes* axes);
    virtual void DrawRuler(VisualRuler* ruler);
    virtual void DrawLabel(VisualLabel *label);
    virtual VisualElementMeta* CreateVisualRowMeta(DocumentManager* docManager, 
        bool brushed, bool hier = false);
    virtual VisualElementMeta* CreateVisualBinMeta(DocumentManager* docManager, bool brushed);
    virtual VisualElementMeta* CreateVisualAxesMeta();
    virtual VisualElementMeta* CreateVisualColumnMeta(DocumentManager* docManager, bool brushed, bool hier);
    virtual VisualElementMeta* CreateVisualMaskMeta(DocumentManager* docManager, bool brushed, bool hier);
	virtual VisualElementMeta* CreateVisualDimensionNameMeta(DocumentManager* docManager);
    virtual VisualElementMeta* CreateVisualDimensionLabelMeta(DocumentManager* docManager);
    virtual VisualElementMeta* CreateVisualRulerMeta(DocumentManager* docManager);
    virtual VisualElementMeta* CreateVisualTimeHistogramMeta(DocumentManager* docManager, bool brushed, bool hier);

    //to display data cluster similariteis, it is the same for all displays
    bool SetShowBand(bool showBand);
    bool SetShowMean(bool showMean);
    bool IsShowBand() {return showBand;}
    bool IsShowMean() {return showMean;}
    bool IsNeedDataClusterMinMaxInfo();

    virtual bool IsNeedDimensionClusterMinMaxInfo();

    virtual void AllDimensionSpaceDeleted() {return;}
    virtual void CurrentDimensionSpaceChanged() {return;}
};

#endif

