#ifndef VarDrawer_H
#define VarDrawer_H

#include "../TableDrawer.h"
#include "VarVisualAxesMeta.h"
#include "VarVisualAxes.h"
#include "VarVisualMask.h"
#include "VarDrawerSettings.h"

class grCanvas;

enum
{ 
    VAR_NONE = 1,
    VAR_MOVE = 2,
};

class VarDrawer : public TableDrawer
{
protected:
    VarDrawerSettings* settings;
    int inputMode;
    int currentDim;

public:
	VarDrawer();
	~VarDrawer();
	
	void PrepareCanvas();
    void PrepareDrawLayer(Layer* layer);
    void AfterDrawLayer(Layer* layer);
	void DrawColumn(VisualColumn *column);
    void DrawAxes(VisualAxes *axes);

    VarDrawerSettings* GetSettings() {return settings;}

    VisualElementMeta* CreateVisualColumnMeta(DocumentManager* docManager, bool brushed, bool hier);
    VisualElementMeta* CreateVisualMaskMeta(DocumentManager* docManager, bool brushed, bool hier);
    VisualElementMeta* CreateVisualAxesMeta();
    VisualElementMeta* CreateVisualTimeHistogramMeta(DocumentManager* docManager, bool brushed, bool hier);

    void ButtonDown(grCanvas* canvas, int button, Vec2 p);
    void ButtonUp(grCanvas* canvas, int button, Vec2 p);
    void MouseMotion(grCanvas* canvas, Vec2 p);  

    void AllDimensionSpaceDeleted(); 
    void CurrentDimensionSpaceChanged();

    int FindDimensionID(float x, float y);
    void SelectedItemsChanged();
    VisualElementMeta* CreateVisualDimensionNameMeta(DocumentManager* docManager);

    void DrawTimeHistogram(VisualTimeHistogram *timeHistogram);
    void DrawMask(VarVisualMask *visMask);

    void DoubleClick(grCanvas* canvas, int button, Vec2 p);

};

#endif

