#include <ctime>
#include "VarDrawerSettings.h"
#include "../../Basic/macros.h"
#include "../../Basic/Vec2.h"

VarDrawerSettings::VarDrawerSettings()
{
    TextureDrawerSettings::TextureDrawerSettings();
//    glyphStyle = PIXEL_VERTICAL;
//    glyphStyle = PIXEL_HORI;
    glyphStyle = PIXEL_SPIRAL;

    maskColor = RGBt(0, 0, 0);
    maskAlpha = 1;
    labelAngle = 0;
}


VarDrawerSettings::~VarDrawerSettings()
{
//    TextureDrawerSettings::~TextureDrawerSettings();
    if (itemHashHash.size() != 0)
    {
        IPHash::iterator it;
        it = itemHashHash.begin();
        while (it != itemHashHash.end())
        {
            delete (ISHash *)(it->second);
            it ++;
        }
    }
    itemHashHash.clear();

    if (importanceHashHash.size() != 0)
    {
        IPHash::iterator it;
        it = importanceHashHash.begin();
        while (it != importanceHashHash.end())
        {
            delete (IIHash *)(it->second);
            it ++;
        }
    }
    importanceHashHash.clear();
}

void VarDrawerSettings::VarMaskColorChanged(RGBt color)
{
    maskColor = color;
}

void VarDrawerSettings::VarMaskAlphaChanged(float alpha)
{
    maskAlpha = alpha;
}

void VarDrawerSettings::SetDisplayMode(int i)
{
    if (i == displayMode)
        return;

    if ((displayMode == 2 && i == 1) || ( i == 2)) 
    {
        labelAngle = -20;
        labelColor = RGBt(1, 1, 0);
    }
    else
    {
        labelAngle = 0;
        labelColor = RGBt(1, 1, 1);
    }

    displayMode = i;
    if (i == 0 || i == 2)
        showSelectedOnly = false;
    else
        showSelectedOnly = true;
}

void VarDrawerSettings::SetItemHash(ISHash *itemHash, int dimID)
{
    IPHash::iterator it;
    it = itemHashHash.find(dimID);
    if (it != itemHashHash.end())
    {
        ISHash *temp = (ISHash *)(it->second);
        delete temp;
    }
    itemHashHash[dimID] = itemHash;
    
}

ISHash* VarDrawerSettings::GetItemHash(int dimID)
{
    IPHash::iterator it;
    it = itemHashHash.find(dimID);
    if (it != itemHashHash.end())
        return (ISHash *)it->second;
    else 
        return NULL;
}

void VarDrawerSettings::SetImportanceHash(IIHash *importanceHash, int dimID)
{
    IPHash::iterator it;
    it = importanceHashHash.find(dimID);
    if (it != importanceHashHash.end())
    {
        IIHash *temp = (IIHash *)(it->second);
        delete temp;
    }
    importanceHashHash[dimID] = importanceHash;
    
}

IIHash* VarDrawerSettings::GetImportanceHash(int dimID)
{
    IPHash::iterator it;
    it = importanceHashHash.find(dimID);
    if (it != importanceHashHash.end())
        return (IIHash *)it->second;
    else 
        return NULL;
}