#ifndef Var_DRAWER_Settings_H
#define Var_DRAWER_Settings_H

//#include <wx/hashset.h>
//#include "../../.h"
#include "../TextureDrawerSettings.h"
#include "../../Basic/macros.h"
#include "../../Basic/RGB.h"


//WX_DECLARE_HASH_SET(int, wxIntegerHash, wxIntegerEqual, IntSet);
   
enum
{ 
	PIXEL_SPIRAL  =   1,
    PIXEL_HCURVE  =   2,
    PIXEL_VERTICAL = 3,
    PIXEL_HORI = 4,
};

 
class VarDrawerSettings : public TextureDrawerSettings
{
protected:
    int glyphStyle;

    float maskAlpha;
    RGBt maskColor;
    RGBt labelColor;
    float labelAngle;
    int timeDimID;

    IPHash itemHashHash;
    IPHash importanceHashHash;

public:
	VarDrawerSettings();
	~VarDrawerSettings();

    float GetMaskAlpha() {return maskAlpha;}
    void SetMaskAlpha(float maskAlpha) {this->maskAlpha = maskAlpha;}

    RGBt GetMaskColor() {return maskColor;}
    void SetMaskColor(RGBt color) {maskColor = color;}

    int GetGlyphStyle() {return glyphStyle;}
    void SetGlyphStyle(int style) {glyphStyle = style;}

    void VarMaskColorChanged(RGBt color);
    void VarMaskAlphaChanged(float alpha);
    void SetDisplayMode(int i);
    float GetAngle() {return labelAngle;}
    int GetTimeDimensionID() {return timeDimID;}
    void SetTimeDimensionID(int id) {timeDimID = id;}

    void SetItemHash(ISHash *itemHash, int dimID);
    ISHash* GetItemHash(int dimID);

    void SetImportanceHash(IIHash *importanceHash, int dimID);
    IIHash* GetImportanceHash(int dimID);

};

#endif

