#ifndef _Var_VISUAL_MASK_H
#define _Var_VISUAL_MASK_H

#include "../TableDrawer.h"
#include "../VisualElement.h"

class VarVisualMask : public VisualElement
{
public:
	GLuint texture;
	int width;
	int height;
	float xPos;
	float yPos;
	float xSize;
	float ySize;

    int dimID;

    float zPos;

public:
	VarVisualMask();
	~VarVisualMask();

    void SetTexture(GLuint texture);
    void SetWidth(int width);        //width: the width of the original texture object
    void SetHeight(int height);      //height: the height of the origianl texture object
    
    void SetXPosition(float x);
    void SetYPosition(float y);
    void SetZPosition(float z);

    void SetXSize(float x);
    void SetYSize(float y);

	GLuint GetTexture();
	int GetWidth();        
	int GetHeight();      
	float GetXPosition();
	float GetYPosition();
	float GetZPosition();
	float GetXSize();
	float GetYSize();

    void SetDimensionID(int id) {dimID = id;}
    int GetDimensionID() {return dimID;}

    void Draw(TableDrawer *drawer);

};

#endif

