#ifndef VideoClipDrawer_H
#define VideoClipDrawer_H

//#include "../../Basic/grCanvas.h"
#include "../TableDrawer.h"
//#include "../VisualElementMeta.h"
//#include "VideoClipVisualDataMeta.h"
//#include "VideoClipVisualData.h"
#include "VideoClipDrawerSettings.h"
#include "VideoClipVisualAxes.h"
//#include "VideoClipVisualLabelMeta.h"
//#include "VideoClipVisualRulerMeta.h"

class grCanvas;
class GryphVisualAxes;

enum
{ 
    VideoClip_NONE = 1,
    VideoClip_MOVE = 2,
};



class VideoClipDrawer : public TableDrawer
{
protected:
    VideoClipDrawerSettings* settings;
    int inputMode;
    int currentItem;

public:
	VideoClipDrawer();
	~VideoClipDrawer();
	
	void PrepareCanvas();
    void PrepareDrawLayer(Layer* layer);
    void AfterDrawLayer(Layer* layer);
	void DrawData(VisualRow *row);

    VideoClipDrawerSettings* GetSettings() {return settings;}

    VisualElementMeta* CreateVisualRowMeta(DocumentManager* docManager, bool brushed, bool hier);
    VisualElementMeta* CreateVisualAxesMeta();

    int FindItemID(float x, float y);
    void ButtonUp(grCanvas* canvas, int button, Vec2 p);
    void MouseMotion(grCanvas* canvas, Vec2 p);
    void ButtonDown(grCanvas* canvas, int button, Vec2 p);
    void DoubleClick(grCanvas* canvas, int button, Vec2 p);
    void SelectedItemsChanged();





};

#endif

