#include "VideoClipVisualAxesMeta.h"
#include "VideoClipVisualAxes.h"
#include "../../DataStructure/DocAxes.h"
#include "../../MainApplication.h"
#include "VideoClipDrawerSettings.h"

VideoClipVisualAxesMeta::VideoClipVisualAxesMeta(VideoClipDrawer* drawer)
{
//    this->drawer = drawer;
	
    settings = (VideoClipDrawerSettings *)drawer->GetSettings();
//
    itemXYFromDataSet = settings->IsXYFromDataSet();
}

VideoClipVisualAxesMeta::~VideoClipVisualAxesMeta()
{
}


VisualElement* VideoClipVisualAxesMeta::InstantVisualElement()
{
    VideoClipVisualAxes* visAxes = new VideoClipVisualAxes();
    
    return visAxes;
}

void VideoClipVisualAxesMeta::Convert(VisualElement* visualEle, DocElement* docEle)
{
    VideoClipVisualAxes* visualAxes = (VideoClipVisualAxes *)visualEle;
    DocAxes* docAxes = (DocAxes *)docEle;

    if (settings->IsXYFromDataSet())
    {
        Vec2* p;
        IPHash* xyHash = docAxes->GetItemXYPosHash();
        IPHash::iterator it;
        for( it = xyHash->begin(); it != xyHash->end(); ++it )
        {
            p = (Vec2*)(it->second);
            settings->SetTextureXYPosition(it->first, p->X, p->Y);
        }
        settings->SetXYFromDataSet(false);
    }
    settings->SetSelectedTextureHash(docAxes->GetSelectedItemHash());
    visualAxes->SetSettings(settings);
}