#ifndef _VideoClip_VISUAL_Row_H
#define _VideoClip_VISUAL_Row_H

#include "../VisualRow.h"

class VideoClipVisualRow : public VisualRow
{
public:
	GLuint texture;
	GLuint maskTexture;
	int width;
	int height;
	float xPos;
	float yPos;
	float zPos;
	float xSize;
	float ySize;

    bool maskMode;
    RGBt color;

    int itemID;

public:
	VideoClipVisualRow();
	~VideoClipVisualRow();

    void SetTexture(GLuint texture);
    void SetMaskTexture(GLuint texture);
    void SetWidth(int width);        //width: the width of the original texture object
    void SetHeight(int height);      //height: the height of the origianl texture object
    
    void SetXPosition(float x);
    void SetYPosition(float y);
    void SetZPosition(float z);
    void SetXSize(float x);
    void SetYSize(float y);

	GLuint GetTexture();
	GLuint GetMaskTexture();
	int GetWidth();        
	int GetHeight();      
	float GetXPosition();
	float GetYPosition();
	float GetZPosition();
	float GetXSize();
	float GetYSize();

    void SetMaskMode(bool mode) {maskMode = mode;}
    bool GetMaskMode() {return maskMode;}
    RGBt GetColor() {return color;}
    void SetColor(RGBt color) {this->color = color;}

    void SetItemID(int id) {itemID = id;}
    int GetItemID() {return itemID;}
    
protected:
    void Init();

};

#endif

