#ifndef _VideoClip_VISUAL_Row_META_H
#define _VideoClip_VISUAL_Row_META_H

#include "../VisualRowMeta.h"
#include "VideoClipDrawer.h"
#include "VideoClipVisualAxes.h"
#include "../VisualElementsIterator.h"

class VisualElementsIterator;
class VideoClipDrawer;

class VideoClipVisualRowMeta : public VisualRowMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    VideoClipDrawer* drawer;
    VideoClipVisualAxes *axes;

    grCanvas* canvas;
    int count;

    int* pos;
    int w, h;
    float* colorData;
    
    int VideoClipStyle;

    int focusItem;

    GLuint maskTexture;

public:
    VideoClipVisualRowMeta();
	VideoClipVisualRowMeta(VideoClipDrawer* drawer, 
        DocumentManager* docManager, bool brushed, bool hier);
	~VideoClipVisualRowMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);

protected:
    void GetBitMap(int VideoClipID, int &w, int &h, float* data, float*& color_data);


};

#endif

