#include "GlyphVisualAxesMeta.h"
#include "GlyphVisualAxes.h"
#include "../../DataStructure/DocAxes.h"
#include "../../MainApplication.h"
#include "GlyphDrawerSettings.h"

GlyphVisualAxesMeta::GlyphVisualAxesMeta(GlyphDrawer* drawer)
{
//    this->drawer = drawer;
	
    settings = (GlyphDrawerSettings *)drawer->GetSettings();
//
    itemXYFromDataSet = settings->IsXYFromDataSet();
}

GlyphVisualAxesMeta::~GlyphVisualAxesMeta()
{
}


VisualElement* GlyphVisualAxesMeta::InstantVisualElement()
{
    GlyphVisualAxes* visAxes = new GlyphVisualAxes();
    
    return visAxes;
}

void GlyphVisualAxesMeta::Convert(VisualElement* visualEle, DocElement* docEle)
{
    GlyphVisualAxes* visualAxes = (GlyphVisualAxes *)visualEle;
    DocAxes* docAxes = (DocAxes *)docEle;

    if (settings->IsXYFromDataSet())
    {
        Vec2* p;
        IPHash* xyHash = docAxes->GetItemXYPosHash();
        IPHash::iterator it;
        for( it = xyHash->begin(); it != xyHash->end(); ++it )
        {
            p = (Vec2*)(it->second);
            settings->SetTextureXYPosition(it->first, p->X, p->Y);
        }
        settings->SetXYFromDataSet(false);
    }
    settings->SetSelectedTextureHash(docAxes->GetSelectedItemHash());
    visualAxes->SetSettings(settings);
}