#ifndef _Glyph_VISUAL_Row_META_H
#define _Glyph_VISUAL_Row_META_H

#include "../VisualRowMeta.h"
#include "GlyphDrawer.h"
#include "GlyphVisualAxes.h"
#include "../VisualElementsIterator.h"

class VisualElementsIterator;
class GlyphDrawer;

class GlyphVisualRowMeta : public VisualRowMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    GlyphDrawer* drawer;
    GlyphVisualAxes *axes;

    grCanvas* canvas;
    int count;

    int* pos;
    int w, h;
    float* colorData;
    
    int glyphStyle;

    int focusItem;

    GLuint maskTexture;

public:
    GlyphVisualRowMeta();
	GlyphVisualRowMeta(GlyphDrawer* drawer, 
        DocumentManager* docManager, bool brushed, bool hier);
	~GlyphVisualRowMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);

protected:
    void GetBitMap(int glyphID, int &w, int &h, float* data, float*& color_data);


};

#endif

