#include <stdio.h>
#include "VisualAxes.h"

VisualAxes::VisualAxes()
{
    dimNum = 0;
    isLeafDim = NULL;
}

VisualAxes::~VisualAxes()
{
    if (isLeafDim != NULL)
        delete [] isLeafDim;
}

bool VisualAxes::SetDimensionNum(int num)
{
    if (num <= 0)
        return false;

    dimNum = num; 
    isLeafDim = new bool [dimNum];

    for (int i = 0; i < dimNum; i++)
    {
        isLeafDim[i] = true;
    }

	return true;
}

//drawer draws a canvas
void VisualAxes::Draw(TableDrawer *drawer)
{
    drawer->DrawAxes(this);
}

bool VisualAxes::IsLeafDimension(int dimID)
{
    return isLeafDim[dimID]; 
}

void VisualAxes::SetLeafDimension(int dimID, bool leafDim)
{
    isLeafDim[dimID] = leafDim;
}   