#include "VarVisualAxesMeta.h"
#include "VarVisualAxes.h"
#include "../../DataStructure/DocAxes.h"
#include "../../MainApplication.h"
//#include "VarDrawerSettings.h"

VarVisualAxesMeta::VarVisualAxesMeta(VarDrawer* drawer)
{
    this->drawer = drawer;
	xSize = 0.2f;
	ySize = 0.2f;
}

VarVisualAxesMeta::~VarVisualAxesMeta()
{
}


VisualElement* VarVisualAxesMeta::InstantVisualElement()
{
    VarVisualAxes* visAxes = new VarVisualAxes();
    
    return visAxes;
}

void VarVisualAxesMeta::Convert(VisualElement* visualEle, DocElement* docEle)
{
    VarVisualAxes* visualAxes = (VarVisualAxes *)visualEle;
    DocAxes* docAxes = (DocAxes *)docEle;

    int dimNum = docAxes->GetDimenionNum();

    visualAxes->SetDimensionNum(dimNum);

    int i;
	int dimID;
/*	VarDrawerSettings* settings = (VarDrawerSettings *)drawer->GetSettings();
	bool distortion = settings->IsDistortionEnabled();
	
	if (distortion)
	{
		float dis_factor = settings->GetDistortionFactor();
		float disXSize = dis_factor * xSize;
		float disYSize = dis_factor * ySize;
		for (i = 0; i < dimNum; i++)
		{
			dimID = docAxes->GetDimensionID(i);
			if (settings->IsDimensionDistorted(dimID))
			{
				visualAxes->SetXSize(i, disXSize);
				visualAxes->SetYSize(i, disYSize);
			}
			else
			{
				visualAxes->SetXSize(i, xSize);
				visualAxes->SetYSize(i, ySize);
			}
		}
	}
	else
	{*/
		for (i = 0; i < dimNum; i++)
		{
				visualAxes->SetXSize(i, xSize);
				visualAxes->SetYSize(i, ySize);
		}
//	}

	float centerx, centery, x_s, y_s;
    for (i = 0; i < dimNum; i++)
    {
		centerx = docAxes->GetXPosition(i);
		centery = docAxes->GetYPosition(i);
		
		x_s = visualAxes->GetXSize(i);
		y_s = visualAxes->GetYSize(i);

		if (centerx-x_s< 0)
            centerx = x_s;
        if (centerx+x_s> 1)
            centerx = 1-x_s;
        if (centery-y_s < 0)
            centery = y_s;
        if (centery+y_s> 1)
            centery = 1-y_s;

        visualAxes->SetXPosition(i, centerx);
        visualAxes->SetYPosition(i, centery);
    }

}