#ifndef VisualLabel_H
#define VisualLabel_H

#include <stdio.h>
#include "VisualElement.h"
#include "TableDrawer.h"

class VisualElement;

class VisualLabel : public VisualElement
{
protected:
    bool isCluster;
    std::string text;
    float x;
    float y;
    float z;
    float angle;
    float scale;
    bool visible;
//    RGBt fgColor;
//    RGBt bgColor;

public:
	VisualLabel();
	~VisualLabel();
	
    void SetText(std::string str);
    void SetX(float x);
    void SetY(float y);
    void SetZ(float z);
    void SetAngle(float angle);
    void SetScale(float scale);
//    void SetForegroundColor(RGBt fgColor);
//    void SetBackgroundColor(RGBt bgColor);

    std::string GetText();
    float GetX();
    float GetY();
    float GetZ();
    float GetAngle();
    float GetScale();
//    RGBt GetForegroundColor();
//    RGBt GetBackgroundColor();

    void Draw(TableDrawer *drawer);
    void SetVisible(bool visible);

};

#endif

