// The interface for setting control modes and parameters of the var display


#include <wx/wx.h>

#include "DBConnectDialog.h"
#include "UserNotifier.h"

BEGIN_EVENT_TABLE(DBConnectDialog, wxDialog)
    EVT_BUTTON(BUTTON_CONNECT, DBConnectDialog::Connect)
//    EVT_TEXT_ENTER(TEXTCTRL_USERNAME, DBConnectDialog::SetUserName)
//    EVT_TEXT_ENTER(TEXTCTRL_PWD, DBConnectDialog::SetPassword)
//    EVT_TEXT_ENTER(TEXTCTRL_URL, DBConnectDialog::SetURL)
END_EVENT_TABLE()

DBConnectDialog::DBConnectDialog(wxWindow* parent, int id, DBManager* dbManager)
        :wxDialog(parent, id, "Connect to DB", wxDefaultPosition, wxDefaultSize)
{
    this->dbManager = dbManager;

    SetBackgroundColour(wxColour(*wxLIGHT_GREY));
    SetForegroundColour(wxColour(*wxBLUE));
    SetModal(true);

    //the sizer contains all stuffs
	topSizer = new wxBoxSizer( wxVERTICAL );
	SetSizer( topSizer );      

    userNameTextCtrl = new wxTextCtrl(this, TEXTCTRL_USERNAME, "", wxDefaultPosition, wxSize(200, 20));
    pwdTextCtrl = new wxTextCtrl(this, TEXTCTRL_PWD, "", wxDefaultPosition, wxSize(200, 20));
    urlTextCtrl = new wxTextCtrl(this, TEXTCTRL_URL, "", wxDefaultPosition, wxSize(200, 20));

    connectButton = new wxButton(this, BUTTON_CONNECT, "Connect", wxPoint(-1,-1), wxSize(-1,-1));

    wxStaticText *label1 = new wxStaticText(this, -1, "UserName", wxDefaultPosition, wxSize(60, 20), wxALIGN_RIGHT );
    wxStaticText *label2 = new wxStaticText(this, -1, "Password", wxDefaultPosition, wxSize(60, 20), wxALIGN_RIGHT );
    wxStaticText *label3 = new wxStaticText(this, -1, "URL", wxDefaultPosition, wxSize(60, 20), wxALIGN_RIGHT );
    wxBoxSizer *sizer1= new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *sizer2= new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *sizer3= new wxBoxSizer(wxHORIZONTAL);
    sizer1->Add(label1, 0, 0, 0);  
    sizer1->Add(userNameTextCtrl, 0, wxEXPAND | wxALL, 1);

    sizer2->Add(label2, 0, 0, 0);  
    sizer2->Add(pwdTextCtrl, 1, wxEXPAND | wxALL, 1);
    
    sizer3->Add(label3, 0, 0, 0);  
    sizer3->Add(urlTextCtrl, 1, wxEXPAND | wxALL, 1);

    topSizer->AddSpacer(30);
    topSizer->Add(sizer1, 0, wxEXPAND | wxLEFT | wxRIGHT, 10); 
    topSizer->AddSpacer(10);
    topSizer->Add(sizer2, 0, wxEXPAND | wxLEFT | wxRIGHT, 10); 
    topSizer->AddSpacer(10);
    topSizer->Add(sizer3, 0, wxEXPAND | wxLEFT | wxRIGHT, 10); 
    topSizer->AddSpacer(10);
    topSizer->Add(connectButton, 0, wxALIGN_CENTER, 4); 
    topSizer->AddSpacer(30);

    Fit();


}

DBConnectDialog::~DBConnectDialog()
{
}

void DBConnectDialog::Connect(wxCommandEvent& event)
{
    userName = userNameTextCtrl->GetValue();
    pwd = pwdTextCtrl->GetValue();
    url = urlTextCtrl->GetValue();

    if ( dbManager->Connect(url, userName, pwd) )
        EndModal(wxID_OK);
    else
        UserNotifier::ShowMessageDialog("", "Connection failed. Please check your input.");
}