// The interface for setting control modes and parameters of the var display

#ifndef DBConnectDialog_H
#define DBConnectDialog_H

#include <string>
#include <wx/wx.h>
#include <wx/dialog.h>
#include "../DBConnection/DBManager.h"

enum  //use 701-799
{ 
    BUTTON_CONNECT =                701,
    TEXTCTRL_USERNAME =             702,
    TEXTCTRL_PWD =                  703,
    TEXTCTRL_URL =                  704,
};


class DBConnectDialog: public wxDialog
{
protected:
    wxBoxSizer* topSizer;

    wxButton* connectButton;

    wxTextCtrl *userNameTextCtrl;
    wxTextCtrl *pwdTextCtrl;
    wxTextCtrl *urlTextCtrl;

    std::string userName, pwd, url;

    DBManager* dbManager;

 public:
    DBConnectDialog(wxWindow* parent, int id, DBManager* dbManager);
	~DBConnectDialog();

    void Connect(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()

};


#endif

