//GLFrame is a frame with a gl canvas in it. Basic canvas 
//operations, such as zooming, panning, image saving can be 
//performed in this frame

//if you need to create a "drawable" window, you can derived it from this class  

#ifndef FRAME_H
#define FRAME_H

#include <wx/wx.h>
#include <wx/filedlg.h>

class ViewManager;
class DocumentManager;


class Frame : public wxFrame
{
protected:
    //each frame contains a pointer to the view manager and docmanger
    ViewManager* viewManager;
    DocumentManager* docManager;

public:
	Frame(wxFrame *parent, int id, const wxChar *title, int xpos, int ypos, int width, int height);
	~Frame();

    void SetViewManager(ViewManager* viewManager) {this->viewManager = viewManager;}
    void SetDocumentManager(DocumentManager* docManager) {this->docManager = docManager;}
    ViewManager* GetViewManager() {return viewManager;}
    DocumentManager* GetDocumentManager() {return docManager;}

	DECLARE_EVENT_TABLE()
};


#endif

