//GLMediaCtrl is a MediaCtrl with a gl canvas in it. Basic canvas 
//operations, such as zooming, panning, image saving can be 
//performed in this MediaCtrl

//if you need to create a "drawable" window, you can derived it from this class  

#ifndef MediaCtrl_H
#define MediaCtrl_H

#include <wx/mediactrl.h>
#include <wx/timer.h>


enum
{
    MEDIACTRL_MENU_UNMUTE = 11,
    MEDIACTRL_MENU_MUTE = 12,
    MEDIACTRL_MENU_PAUSE = 13,
    MEDIACTRL_MENU_PLAY = 14,
    MEDIACTRL_MENU_STOP = 15,
    MEDIACTRL_MENU_PLAYALL = 16,
    MEDIACTRL_MENU_STOPALL = 17,
    MEDIACTRL_MENU_PAUSEALL = 18,
    MEDIACTRL_MENU_MUTEALL = 19,

    TIMER_ID = 20,
};

class MediaCtrl : public wxMediaCtrl
{
protected:
    wxMenu* menu;
    wxString fileName;
    wxTimer *timer;

    int startTime;
    int endTime;
    int lastingTime;

public:
    MediaCtrl(wxWindow* parent, wxWindowID id, const wxString& fileName = wxT(""));
    MediaCtrl(wxWindow* parent, wxWindowID id, const wxString& fileName, int startTime, int endTime);
    ~MediaCtrl();

    void OnMediaStop(wxMediaEvent& event);
    void OnLeftMouseDown(wxMouseEvent& event);
    void OnRightMouseDown(wxMouseEvent& event);
    void OnLeftMouseDoubleClick(wxMouseEvent& event);

    void OnMenuUnmute(wxCommandEvent& event);
    void OnMenuMute(wxCommandEvent& event);
    void OnMenuPause(wxCommandEvent& event);
    void OnMenuPlay(wxCommandEvent& event);
    void OnMenuStop(wxCommandEvent& event);
    void OnMenuStopAll(wxCommandEvent& event);
    void OnMenuPauseAll(wxCommandEvent& event);
    void OnMenuPlayAll(wxCommandEvent& event);
    void OnMenuMuteAll(wxCommandEvent& event);

    void ImportantPlay();
    void OnTimer(wxTimerEvent& event);

	DECLARE_EVENT_TABLE()
};


#endif

