#include "MultipleMediaCtrl.h"
#include "ViewMultipleVideoWindow.h"
#include "interface/ViewVideoWindow.h"

BEGIN_EVENT_TABLE(MultipleMediaCtrl, MediaCtrl)
    EVT_TIMER(MTIMER_ID, MultipleMediaCtrl::OnTimer)

END_EVENT_TABLE()

MultipleMediaCtrl::MultipleMediaCtrl(wxWindow* parent, wxWindowID id, std::string path, VideoShotIterator *it)
        :MediaCtrl(parent, id)
{
    this->path = path;

    if (it->IsDone())
        fileName = "";
    else
    {
        prevFileName = "";
        DocVideoShot *shot = (DocVideoShot *)(it->GetNext());
        fileName = path + "\\" + shot->GetVideoName();
//        fileName = "C:\\yangjing\\Fan\\video\\multichannel\\Fox\\2006_07_17_X_01_52.mpg";
        startTime = shot->GetStartTime();
        endTime = shot->GetEndTime();
        lastingTime = endTime - startTime;
        Load(fileName.c_str());
    }
    
    timer = new wxTimer(this, MTIMER_ID);

}

MultipleMediaCtrl::~MultipleMediaCtrl()
{
    delete it;
}

void MultipleMediaCtrl::OnTimer(wxTimerEvent& event)
{
    if (it->IsDone())
        fileName = "";
    else
    {
        prevFileName = fileName;
        DocVideoShot *shot = (DocVideoShot *)(it->GetNext());
        fileName = path + "\\" + shot->GetVideoName();
        if (fileName.compare(prevFileName) != 0)
        {
//fileName = "C:\\yangjing\\Fan\\video\\multichannel\\Fox\\2006_07_17_X_01_52.mpg";
            Load(fileName.c_str());
        }
        startTime = shot->GetStartTime();
        endTime = shot->GetEndTime();
        lastingTime = endTime - startTime;

        Play();
    }
}

void MultipleMediaCtrl::Play()
{
    if (fileName.compare("") != 0)
    {
        wxMediaCtrl::Play();
        Seek(startTime, wxFromStart);
        timer->Start(lastingTime, wxTIMER_ONE_SHOT);
    }
}

