#include "UserNotifier.h"
#include <wx/msgdlg.h>

wxProgressDialog* UserNotifier::progressDlg = NULL;

void UserNotifier::CreateProgressDialog(std::string title, std::string message, int max)
{
    if (progressDlg != NULL)
        DeleteProgressDialog();
    progressDlg = new wxProgressDialog(title.c_str(), message.c_str(), max, 
        NULL, wxPD_AUTO_HIDE | wxPD_APP_MODAL | wxPD_CAN_ABORT);
    progressDlg->CenterOnScreen();
    progressDlg->SetSize(200, 400, 600, 200);
    progressDlg->Show(true);
}

bool UserNotifier::UpdateProgressDialog(int progress, std::string message)
{
    return progressDlg->Update(progress, message.c_str());
}

void UserNotifier::DeleteProgressDialog()
{
    delete progressDlg;
    progressDlg = NULL;
}

void UserNotifier::ShowMessageDialog(std::string title, std::string message)
{
    wxMessageDialog dlg(NULL, message.c_str(), title.c_str(), wxOK, wxDefaultPosition);
    dlg.ShowModal();
}

