#include <wx/wx.h>
#include <fstream>

#include "ViewCloseCaptionWindow.h"

BEGIN_EVENT_TABLE(ViewCloseCaptionWindow, wxFrame)
END_EVENT_TABLE()

ViewCloseCaptionWindow::ViewCloseCaptionWindow(std::string videoFile, std::string keyword) : 
    wxFrame(NULL, -1, videoFile.c_str(), wxPoint(600, 10))
{
    std::string ccFile;
    ccFile = videoFile.substr(0, videoFile.find('.'));
    ccFile += ".cc";
    wxString wccFile = ccFile.c_str();
    wccFile += "  ";
    wccFile += keyword.c_str();
    SetTitle(wccFile.Right(wccFile.Length() - wccFile.Find('\\', true) - 1));

	wxBoxSizer *sizer = new wxBoxSizer( wxVERTICAL );
	SetSizer( sizer );      

    textCtrl = new wxTextCtrl(this, TEXTCTRLID, "", wxDefaultPosition, wxSize(800, 900), 
        wxTE_MULTILINE | wxTE_READONLY | wxHSCROLL | wxTE_RICH );
    std::ifstream infile (ccFile.c_str());

    wxString temp = keyword.c_str();
    temp.Replace("_", " ");
    keyword = temp.c_str();
    char buf[1000];
    infile.getline(buf, 1000);
    wxString str;
    textCtrl->SetDefaultStyle(wxTextAttr(*wxBLACK));
    while (infile.good())
    {
        infile.getline(buf, 1000);
        str = buf; 
        bool exist = false;
        std::string line = str.MakeLower().c_str();
        int pos = line.find(keyword.c_str()); 
        if (pos >= 0)
        {
            if (pos == 0 || !isalpha(str[pos-1]))
            {
                int pos2 = pos + keyword.length();
                if (pos2 == line.length() || !isalpha(line[pos2]))
                    exist = true;
            }
        }
        if (exist == true)
        {
            wxTextAttr style = textCtrl->GetDefaultStyle();
            textCtrl->SetDefaultStyle(wxTextAttr(*wxRED));
            textCtrl->AppendText(str.c_str());
            textCtrl->AppendText("\n");
            textCtrl->SetDefaultStyle(wxTextAttr(*wxBLACK));
        }
        else
        {
            textCtrl->AppendText(str.c_str());
            textCtrl->AppendText("\n");
        }
    }

    sizer->Add(textCtrl, 1, wxEXPAND | wxALL, 0);

    Fit();
}

ViewCloseCaptionWindow::~ViewCloseCaptionWindow()
{
}

