#include <wx/wx.h>
#include <wx/image.h>
#include "ViewImageWindow.h"

BEGIN_EVENT_TABLE(ViewImageWindow, wxFrame)
    EVT_PAINT(ViewImageWindow::OnPaint)
//    EVT_SIZE(ViewImageWindow::OnSize)
END_EVENT_TABLE()

ViewImageWindow::ViewImageWindow(wxString &imageFile) : 
    wxFrame(NULL, -1, imageFile)
{
    wxImage image(imageFile);
    int w = image.GetWidth();
    int h = image.GetHeight();
    bitmap = new wxBitmap(image);
    SetSize(-1, -1, w+8, h+54);
    SetTitle(imageFile.Right(imageFile.Length() - imageFile.Find('\\', true) - 1));
}

ViewImageWindow::~ViewImageWindow()
{
    delete bitmap;
}

void ViewImageWindow::OnPaint(wxPaintEvent& event)
{
    wxPaintDC dc(this);

    dc.DrawBitmap(*bitmap, 0, 0, false);
}
